;======================================================================================
;
; Nov 2009 - BFF_Motion_Driver with Visual System Driver, - X-Plane Version v3.0 beta - 8.4 DOF version for hexapod platform designs alone
;
; © Copyright 2007, 2008, 2009, 2010 BFF Design Ltd
;
; 
; Author; Ian Hopper (BFF Design Ltd) - http://buggies.builtforfun.co.uk/ - email - Ian@builtforfun.co.uk
;
;======================================================================================
;
; This software has been provided WITHOUT ANY WARRANTY
; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
; A PARTICULAR PURPOSE.
;
; This software is licensed for your personal NON-COMMERCIAL use only. You 
; may not further distribute this software. You may not re-engineer or modify this
; software.
;
;======================================================================================

#NoEnv ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input ; Recommended for new scripts due to its superior speed and reliability.

; Conditions needed to maximise running speed of script

SetBatchLines -1
Process Priority,,Normal		;Comment this out if fs plays up - doesn't make much difference on my machine
SetKeyDelay -1
SetFormat, floatfast, 0.20

pi := 3.141592653589793

SetTitleMatchMode, 1
SetTitleMatchMode, Fast

; Bring in the external scripts with the functions

#Include CalcPitch4.ahk
#Include CalcRoll7.ahk
#Include CalcHeave3.ahk

#Include CalcYaw1.ahk
#Include CalcSurge1.ahk
#Include CalcSway1.ahk

#Include Hexapod_5.ahk

#Include BFF_Functions_3-17PSX.ahk
#Include Read_Config_3-14.ahk
#Include Write_Config_3-3.ahk
#Include Scope4.ahk
#Include Termi-BUS.ahk
#Include Tool_Tips2.ahk
#Include Gaussian_Functions.ahk

#Include DataTrace.ahk

#Include Kang_Funcs_3.ahk
#Include BFFCOMMS_Func3.ahk

#Include BFF_TCP_Funcs_1.ahk
#Include BFF_Filter_Funcs2.ahk

Menu, Tray,  Icon, favicon.ico, 1

;OnExit, Finish
OnMessage(0x200, "WM_MOUSEMOVE")

FileDelete, BFF_Comms.log
FileDelete, 6DOF.log
FileAppend, ===============`n, 6DOF.log
FileAppend, 6DOF Motion Driver started at: %A_Now%`n, 6DOF.log
FileAppend, ===============`n`n, 6DOF.log
;
;=========================================================================
;Define the main user interface window
;=========================================================================
;
;Check the dpi settings and set the font size
RegRead, DPI_value, HKEY_CURRENT_USER, Control Panel\Desktop\WindowMetrics, AppliedDPI
if (errorlevel = 1) OR (DPI_value = 96)
  DPI_F := 1
else
  DPI_F := DPI_Value / 96

s_val := 8 / DPI_F
s_val := "s" . Floor(s_val)
w_val := "w" . 400 * DPI_F
w_val_bold := "w" . 600 * DPI_F

Gui, Font, %s_val%


Gui, Color, Silver
Gui, Add, Progress, x29 y89 w400 h10 vMyProgress, 
Gui, Add, Text, x42 y458 w380 h25 +Center, To toggle recorded light turbulence heave motion on/off.....  BackSlash+B`n(To initiate new light-turbulence recording run.....  BackSlash+R - will overwrite!)
Gui, Font, underline, 
Gui, Add, Text, x29 y487 w400 h20 +Center cBlue gLaunchBFF, BFF_Simulation_Website
Gui, Font, normal, 
Gui, Add, Button, x22 y105 w50 h20 , Start
Gui, Add, Button, x81 y105 w50 h20 , Exit
Gui, Add, Button, x304 y353 w21 h20 , R
Gui, Add, Button, x282 y353 w21 h20 , P
Gui, Add, Button, x326 y353 w21 h20 , H
Gui, Add, Button, x347 y353 w21 h20 , Y
Gui, Add, Button, x368 y353 w21 h20 , M
Gui, Add, Text, x29 y382 w400 h13 +Center vMyText, 
Gui, Add, Text, x29 y397 w400 h13 +Center vMyText2, 
Gui, Add, Text, x29 y412 w400 h13 +Center vMyText3, 
Gui, Add, Text, x29 y134 w150 h15 vPitchOut, Pitch Cue Output...
Gui, Add, Progress, x30 y151 w400 h10 vPitchBar, 
Gui, Add, Text, x29 y164 w150 h15 vRollOut, Roll Cue Output...
Gui, Add, Progress, x30 y180 w400 h10 vRollBar, 
Gui, Add, Text, x29 y193 w150 h15 vHeaveOut, Heave Cue Output...
Gui, Add, Progress, x30 y209 w400 h10 vHeaveBar, 
Gui, Add, Text, x29 y223 w150 h15 vSurgeOut, Surge Cue Output...
Gui, Add, Progress, x30 y241 w400 h10 vSurgeBar, 
Gui, Add, Text, x29 y253 w150 h15 vSwayOut, Sway Cue Output...
Gui, Add, Progress, x30 y269 w400 h10 vSwayBar, 
Gui, Add, Text, x29 y282 w125 h15 vYawOut, Yaw Cue Output...
Gui, Add, Progress, x30 y300 w400 h10 vYawBar, 
Gui, Add, Text, x155 y284 w290 h15 vHexOut, 
Gui, Add, Text, x41 y511 w170 h20 +Center, Copyright 2010-15 BFF Design Ltd
Gui, Add, GroupBox, x9 y4 w443 h437 cBlack, BFF MOTION DRIVER V3.406
Gui, Add, GroupBox, x8 y442 w444 h91 cBlack, INFORMATION
Gui, Add, GroupBox, x16 y72 w430 h363 cBlack, MOTION DRIVER
Gui, Add, Text, x221 y503 w200 h25 +Center vText_Lic, See license file for details`nof allowable use.
Gui, Add, Picture, x16 y28 w430 h40 , bannerPSX.jpg
Gui, Add, GroupBox, x16 y19 w429 h50 , 
Gui, Add, Button, x322 y327 w110 h20 , Disp_Data
Gui, Add, Button, x32 y326 w90 h20 , Hold_Start_Pos
Gui, Add, Button, x132 y326 w90 h20 , _Drive
Gui, Font, w600, 
Gui, Add, Text, x232 y329 w81 h17 vMyText7, 
Gui, Font, w400, 
Gui, Add, Text, x330 y135 w100 h15 vTCP_Text, 
Gui, Add, Button, x258 y105 w50 h20 , Capture
Gui, Add, Button, x21 y351 w110 h20 , Manual_Override
Gui, Add, CheckBox, x134 y347 w129 h30 vACT_DOF, By Act (unchecked) or By DOF (checked)
Gui, Add, Button, x388 y105 w50 h20 , Info
Gui, Add, GroupBox, x26 y371 w398 h9 , 
Gui, Add, Button, x310 y105 w24 h20 , S1
Gui, Add, Button, x335 y105 w24 h20 , S2
Gui, Add, Button, x360 y105 w24 h20 , S3
Gui, Add, CheckBox, x392 y350 w40 h15 vAdvanced, Adv.
Gui, Show, x50 y50 h444 w460, BFF 6-DOF Platform Motion Driver v3

;The flight data capture window
Gui 2:Default
Gui, Color, Silver
Gui, Add, GroupBox, x5 y4 w478 h159 , Flight Data Limits Capture
Gui, Add, Button, x92 y137 w80 h20 , Re_Set
Gui, Add, Button, x326 y138 w80 h20 , Close
Gui, Add, Text, x11 y56 w30 h20 , Max.
Gui, Add, Text, x43 y23 w60 h30 +Center, FWD  Accel.
Gui, Add, Edit, x43 y53 w60 h20 vFwd1, 
Gui, Add, Text, x11 y86 w30 h20 , Min.
Gui, Add, Edit, x43 y83 w60 h20 vFwd2, 
Gui, Add, Edit, x113 y53 w60 h20 vL1, 
Gui, Add, Edit, x113 y83 w60 h20 vL2, 
Gui, Add, Edit, x183 y53 w60 h20 vV1, 
Gui, Add, Edit, x183 y83 w60 h20 vV2, 
Gui, Add, Edit, x343 y53 w60 h20 vP1, 
Gui, Add, Edit, x343 y83 w60 h20 vP2, 
Gui, Add, Edit, x413 y53 w60 h20 vB1, 
Gui, Add, Edit, x413 y83 w60 h20 vB2, 
Gui, Add, Text, x113 y23 w60 h30 +Center, LAT    Accel.
Gui, Add, Text, x183 y23 w60 h30 +Center, VERT Accel.
Gui, Add, Text, x343 y23 w60 h30 +Center, Pitch Angle
Gui, Add, Text, x413 y23 w60 h30 +Center, Bank Angle
Gui, Add, Text, x43 y113 w60 h20 +Center, m/s^2
Gui, Add, Text, x113 y113 w60 h20 +Center, m/s^2
Gui, Add, Text, x183 y113 w60 h20 +Center, m/s^2
Gui, Add, Text, x343 y113 w60 h20 +Center, Deg.
Gui, Add, Text, x413 y113 w60 h20 +Center, Deg.
Gui, Add, Text, x259 y23 w50 h29 +Center, YAW Vel.
Gui, Add, Edit, x253 y53 w60 h20 vY1, 
Gui, Add, Edit, x253 y83 w60 h20 vY2, 
Gui, Add, Text, x252 y113 w60 h20 +Center, rad/s
Gui, Show, x50 y50 h175 w491, Flight Data Limits Capture
Gui, Cancel

;The Manual Override window
Gui 3:Default
Gui, Color, Silver
Gui, Add, GroupBox, x8 y4 w443 h401 , Position Demand Manual Override
Gui, Add, CheckBox, x182 y22 w70 h20 vEnable_1 gEnable_1, Enable_1
Gui, Add, Slider, x22 y42 w420 h30 ToolTipRight vman_pos1, 127
Gui, Add, Text, x32 y22 w140 h20 , Act1/Pitch - Manual Control
Gui, Add, Text, x32 y72 w20 h20 , Min
Gui, Add, Text, x422 y72 w20 h20 , Max
Gui, Add, Text, x32 y92 w140 h20 , Act2/Roll - Manual Control
Gui, Add, CheckBox, x182 y92 w70 h20 vEnable_2 gEnable_2, Enable_2
Gui, Add, Slider, x22 y112 w420 h30 ToolTipRight vman_pos2, 127
Gui, Add, Text, x32 y147 w140 h20 , Act3/Heave - Manual Control
Gui, Add, CheckBox, x182 y147 w70 h20 vEnable_3 gEnable_3, Enable_3
Gui, Add, Slider, x22 y167 w420 h30 ToolTipRight vman_pos3, 127
Gui, Add, Text, x32 y202 w140 h20 , Act4/Surge - Manual Control
Gui, Add, CheckBox, x182 y201 w70 h20 vEnable_4 gEnable_4, Enable_4
Gui, Add, Slider, x22 y222 w420 h30 ToolTipRight vman_pos4, 127
Gui, Add, Text, x32 y257 w140 h20 , Act5/Sway - Manual Control
Gui, Add, CheckBox, x182 y257 w70 h20 vEnable_5 gEnable_5, Enable_5
Gui, Add, Slider, x21 y277 w420 h30 ToolTipRight vman_pos5, 127
Gui, Add, Text, x32 y313 w140 h20 , Act6/Yaw - Manual Control
Gui, Add, CheckBox, x181 y312 w70 h20 vEnable_6 gEnable_6, Enable_6
Gui, Add, Slider, x21 y334 w420 h30 ToolTipRight vman_pos6, 127
Gui, Add, CheckBox, x32 y372 w100 h30 vTogether gTogether, Follow Act 1
Gui, Add, Button, x374 y372 w69 h26 vClose, Close
Gui, Show, x50 y50 h413 w463, Position Demand Manual Override

GuiControl, +Range0-255, man_pos1
GuiControl, +Range0-255, man_pos2
GuiControl, +Range0-255, man_pos3
GuiControl, +Range0-255, man_pos4
GuiControl, +Range0-255, man_pos5
GuiControl, +Range0-255, man_pos6
GuiControl,, man_pos1, 127
GuiControl,, man_pos2, 127
GuiControl,, man_pos3, 127
GuiControl,, man_pos4, 127
GuiControl,, man_pos5, 127
GuiControl,, man_pos6, 127
GuiControl, Disable, man_pos1
GuiControl, Disable, man_pos2
GuiControl, Disable, man_pos3
GuiControl, Disable, man_pos4
GuiControl, Disable, man_pos5
GuiControl, Disable, man_pos6

Gui, Cancel

;The Pitch cue settings window
Gui 4:Default
Gui, Color, Silver
Gui, Add, GroupBox, x6 y10 w385 h233 , Pitch Cue Detailed Settings
Gui, Add, Text, x17 y28 w360 h16 , Forward acceleration scaling factors
Gui, Add, Text, x17 y46 w105 h20 , P4 Vehic On Ground
Gui, Add, Edit, x122 y46 w70 h20 vFaScaleg, 
Gui, Add, Text, x217 y46 w90 h20 , P5 Vehic In Flight
Gui, Add, Edit, x310 y46 w62 h20 vFaScalea, 
Gui, Add, Text, x17 y72 w360 h20 , Forward acceleration low frequency isolation filter - Time Constants
Gui, Add, Edit, x122 y90 w40 h20 vTCfg, 
Gui, Add, Text, x17 y92 w105 h20 , P6 Vehic On Ground
Gui, Add, Text, x167 y90 w30 h20 , s/rad
Gui, Add, Text, x217 y92 w90 h20 , P7 Vehic In Flight
Gui, Add, Edit, x307 y90 w40 h20 vTCfa, 
Gui, Add, Text, x348 y92 w32 h18 , s/rad
Gui, Add, Text, x17 y122 w165 h20 , P8 Forward acceleration cap level
Gui, Add, Edit, x182 y120 w40 h20 vFaCap, 
Gui, Add, Text, x227 y122 w40 h20 , m/s^2
Gui, Add, Button, x12 y423 w82 h25 , Close
Gui, Add, Button, x157 y423 w82 h25 , Use
Gui, Add, Button, x303 y423 w82 h25 , Save
Gui, Add, Text, x17 y172 w255 h20 , P10 Proportion of Pitch Angle to add for pitch-rate cue
Gui, Add, Edit, x278 y171 w40 h20 vRateP, 
Gui, Add, Text, x17 y192 w230 h20 , P11 Pitch rate cue washout filter - Time Constant
Gui, Add, Edit, x267 y192 w40 h20 vTCpr, 
Gui, Add, Text, x312 y194 w30 h20 , s/rad
Gui, Add, Text, x17 y144 w260 h20 , P9 Forward acceleration washout filter - Time Constant
Gui, Add, Edit, x275 y140 w40 h20 vTCpa, 
Gui, Add, Text, x318 y142 w30 h20 , s/rad
Gui, Add, Text, x17 y218 w260 h20 , P12 Output pitch cue to give full range movement  +/-
Gui, Add, Edit, x276 y216 w40 h20 vFAMax, 
Gui, Add, Text, x320 y220 w30 h20 , rad
Gui, Add, Text, x17 y267 w360 h20 , Surge acceleration high frequency isolation filter - Time Constants
Gui, Add, Text, x17 y287 w117 h20 , P13 Vehic On Ground
Gui, Add, Edit, x133 y287 w40 h20 vTCSUg, 
Gui, Add, Text, x220 y287 w100 h20 , P14 Vehic In Flight
Gui, Add, Text, x174 y288 w30 h20 , s/rad
Gui, Add, Edit, x321 y287 w40 h20 vTCSUa, 
Gui, Add, Text, x363 y288 w30 h20 , s/rad
Gui, Add, Text, x17 y317 w160 h20 , P15 Surge acceleration cap level
Gui, Add, Edit, x175 y317 w40 h20 vSUaCap, 
Gui, Add, Text, x226 y318 w40 h20 , m/s^2
Gui, Add, Text, x17 y341 w210 h20 , Surge cue smoothing filter - Time Constants
Gui, Add, Text, x17 y359 w117 h20 , P16 Vehic On Ground
Gui, Add, Edit, x134 y357 w40 h20 vTCSU1g, 
Gui, Add, Text, x175 y359 w30 h19 , s/rad
Gui, Add, Text, x221 y358 w100 h20 , P17 Vehic In Flight
Gui, Add, Edit, x321 y357 w40 h20 vTCSU1a, 
Gui, Add, Text, x363 y358 w30 h20 , s/rad
Gui, Add, Text, x17 y389 w259 h20 , P18 Output surge cue to give full range movement  +/-
Gui, Add, Edit, x280 y388 w40 h20 vSUaMax, 
Gui, Add, Text, x325 y389 w40 h20 , m/s^2
Gui, Add, GroupBox, x6 y246 w385 h169 , Surge Cue Detailed Settings
Gui, Show, x50 y50 h458 w402, Pitch Cue Settings
Gui, Cancel


;The Roll cue settings window
Gui 5:Default
Gui, Color, Silver
Gui, Add, GroupBox, x6 y10 w385 h233 , Roll Cue Detailed Settings
Gui, Add, Text, x17 y28 w360 h16 , Lateral acceleration scaling factors
Gui, Add, Text, x17 y46 w105 h20 , R4 Vehic On Ground
Gui, Add, Edit, x122 y46 w70 h20 vLaScaleg, 
Gui, Add, Text, x217 y46 w90 h20 , R5 Vehic In Flight
Gui, Add, Edit, x310 y46 w62 h20 vLaScalea, 
Gui, Add, Text, x17 y72 w360 h20 , Lateral acceleration low frequency isolation filter - Time Constants
Gui, Add, Edit, x122 y90 w40 h20 vTCllg, 
Gui, Add, Text, x17 y92 w105 h20 , R6 Vehic On Ground
Gui, Add, Text, x167 y90 w30 h20 , s/rad
Gui, Add, Text, x217 y92 w90 h20 , R7 Vehic In Flight
Gui, Add, Edit, x307 y90 w40 h20 vTClla, 
Gui, Add, Text, x348 y92 w32 h18 , s/rad
Gui, Add, Text, x17 y122 w165 h20 , R8 Lateral acceleration cap level
Gui, Add, Edit, x182 y120 w40 h20 vLaCap, 
Gui, Add, Text, x227 y122 w40 h20 , m/s^2
Gui, Add, Button, x12 y423 w82 h25 , Close
Gui, Add, Button, x157 y423 w82 h25 , Use
Gui, Add, Button, x303 y423 w82 h25 , Save
Gui, Add, Text, x17 y172 w255 h20 , R10 Proportion of Roll Angle to add for Roll-rate cue
Gui, Add, Edit, x278 y171 w40 h20 vRateF, 
Gui, Add, Text, x17 y192 w230 h20 , P11 Roll rate cue washout filter - Time Constant
Gui, Add, Edit, x267 y192 w40 h20 vTCl, 
Gui, Add, Text, x312 y194 w30 h20 , s/rad
Gui, Add, Text, x17 y144 w260 h20 , R9 Lateral acceleration washout filter - Time Constant
Gui, Add, Edit, x275 y140 w40 h20 vTCla, 
Gui, Add, Text, x318 y142 w30 h20 , s/rad
Gui, Add, Text, x17 y218 w260 h20 , R12 Output Roll cue to give full range movement  +/-
Gui, Add, Edit, x276 y216 w40 h20 vLaMax, 
Gui, Add, Text, x325 y220 w30 h20 , rad
Gui, Add, Text, x17 y267 w360 h20 , Sway acceleration high frequency isolation filter - Time Constants
Gui, Add, Text, x17 y287 w117 h20 , R13 Vehic On Ground
Gui, Add, Edit, x133 y287 w40 h20 vTCSWg, 
Gui, Add, Text, x220 y287 w100 h20 , R14 Vehic In Flight
Gui, Add, Text, x174 y288 w30 h20 , s/rad
Gui, Add, Edit, x321 y287 w40 h20 vTCSWa, 
Gui, Add, Text, x363 y288 w30 h20 , s/rad
Gui, Add, Text, x17 y317 w160 h20 , R15 Sway acceleration cap level
Gui, Add, Edit, x175 y317 w40 h20 vSWaCap, 
Gui, Add, Text, x226 y318 w40 h20 , m/s^2
Gui, Add, Text, x17 y341 w210 h20 , Sway cue smoothing filter - Time Constants
Gui, Add, Text, x17 y359 w117 h20 , R16 Vehic On Ground
Gui, Add, Edit, x134 y357 w40 h20 vTCSW1g, 
Gui, Add, Text, x175 y359 w30 h19 , s/rad
Gui, Add, Text, x221 y358 w100 h20 , R17 Vehic In Flight
Gui, Add, Edit, x321 y357 w40 h20 vTCSW1a, 
Gui, Add, Text, x363 y358 w30 h20 , s/rad
Gui, Add, Text, x17 y389 w259 h20 , R18 Output Sway cue to give full range movement  +/-
Gui, Add, Edit, x280 y388 w40 h20 vSWaMax, 
Gui, Add, Text, x325 y389 w40 h20 , m/s^2
Gui, Add, GroupBox, x6 y246 w385 h169 , Sway Cue Detailed Settings
; Generated using SmartGUI Creator 4.0
Gui, Show, x50 y50 h459 w404, Roll Cue Settings
Gui, Cancel


;The Heave cue settings window
Gui 6:Default
Gui, Color, Silver
Gui, Add, GroupBox, x6 y5 w388 h312 , Heave Cue Settings
Gui, Add, Text, x15 y29 w360 h16 , Vertical acceleration scaling factors
Gui, Add, Text, x15 y51 w110 h20 , H1 Vehic On Ground
Gui, Add, Edit, x128 y51 w70 h20 vVaScaleg, 
Gui, Add, Text, x217 y51 w90 h20 , H2 Vehic In Flight
Gui, Add, Edit, x312 y51 w62 h20 vVaScalea, 
Gui, Add, Text, x15 y87 w360 h20 , H3 Heave acceleration smoothing/delay filter - Time Constant
Gui, Add, Edit, x310 y85 w30 h20 vTCva, 
Gui, Add, Text, x345 y87 w30 h20 , s/rad
Gui, Add, Text, x15 y116 w305 h20 , H4 Raise heave accelerations above 1.0 m/s^2 to the power....
Gui, Add, Edit, x320 y114 w40 h20 vVaPw, 
Gui, Add, Text, x15 y145 w190 h20 , H5 Scaled heave acceleration cap level
Gui, Add, Edit, x209 y143 w40 h20 vVaSat, 
Gui, Add, Text, x255 y145 w40 h20 , m/s^2
Gui, Add, Text, x15 y171 w255 h20 , H6 Heave acceleration washout filter - Time Constant
Gui, Add, Edit, x270 y169 w40 h20 vTCvp, 
Gui, Add, Text, x315 y171 w30 h20 , s/rad
Gui, Add, Text, x15 y268 w330 h20 , H9 Scaling factor to apply to recorded light-turb movement - in flight
Gui, Add, Edit, x355 y266 w30 h20 vTurb_Scalea, 
Gui, Add, Text, x15 y290 w310 h20 , H10 Scaling factor to apply to generated runway heave.
Gui, Add, Edit, x355 y288 w30 h20 vTurb_Scaleg, 
Gui, Add, Text, x15 y197 w250 h20 , H7 Heave cue final smoothing filter - Time Constant
Gui, Add, Edit, x260 y195 w40 h20 vTCvf, 
Gui, Add, Text, x307 y197 w30 h20 , s/rad
Gui, Add, Text, x15 y232 w250 h20 , H8 Heave cue to give full range movement          +/-
Gui, Add, Edit, x267 y230 w40 h20 vVaMax, 
Gui, Add, Text, x313 y232 w40 h20 , m/s^2
Gui, Add, Button, x12 y325 w82 h25 , Close
Gui, Add, Button, x164 y326 w82 h25 , Use
Gui, Add, Button, x308 y326 w82 h25 , Save
Gui, Show, x50 y50 h359 w403, Heave Cue Settings
Gui, Cancel


;The actuator stroke mix settings window
Gui 7:Default
Gui, Color, Silver
Gui, Add, GroupBox, x7 y8 w383 h153 , Actuator Cue Mix
Gui, Add, Button, x12 y177 w82 h25 , Close
Gui, Add, Button, x157 y177 w82 h25 , Use
Gui, Add, Button, x303 y177 w82 h25 , Save
Gui, Add, Text, x15 y37 w220 h20 , `% of Available Range the Pitch Cue can use
Gui, Add, Edit, x245 y37 w40 h20 vPitch_prop, 
Gui, Add, Text, x15 y57 w220 h20 , `% of Available Range the Roll Cue can use
Gui, Add, Edit, x245 y57 w40 h20 vRoll_prop, 
Gui, Add, Text, x15 y77 w220 h20 , `% of Available Range the Heave Cue can use
Gui, Add, Edit, x245 y77 w40 h20 vHeave_prop, 
Gui, Add, Text, x295 y37 w10 h20 , `%
Gui, Add, Text, x295 y57 w10 h20 , `%
Gui, Add, Text, x295 y77 w10 h20 , `%
Gui, Add, Text, x296 y139 w10 h20 , `%
Gui, Add, Text, x295 y118 w10 h20 , `%
Gui, Add, Text, x296 y98 w10 h20 , `%
Gui, Add, Edit, x245 y98 w40 h20 vSurge_prop, 
Gui, Add, Edit, x245 y118 w40 h20 vSway_prop, 
Gui, Add, Edit, x245 y138 w40 h20 vYaw_prop, 
Gui, Add, Text, x15 y98 w220 h20 , `% of Available Range the Surge Cue can use
Gui, Add, Text, x15 y118 w220 h20 , `% of Available Range the Sway Cue can use
Gui, Add, Text, x15 y138 w220 h20 , `% of Available Range the Yaw Cue can use
Gui, Add, Text, x313 y21 w29 h15 , Invert
Gui, Add, Text, x346 y21 w35 h15 , Disable
Gui, Add, CheckBox, x320 y36 w16 h19 vPitch_Rev, 
Gui, Add, CheckBox, x320 y57 w16 h19 vRoll_Rev, 
Gui, Add, CheckBox, x320 y77 w16 h19 vHeave_Rev, 
Gui, Add, CheckBox, x320 y98 w16 h19 vSurge_Rev, 
Gui, Add, CheckBox, x320 y118 w16 h19 vSway_Rev, 
Gui, Add, CheckBox, x320 y137 w16 h19 vYaw_Rev, 
Gui, Add, CheckBox, x354 y36 w16 h19 vPitch_prop_disable, 
Gui, Add, CheckBox, x354 y57 w16 h19 vRoll_prop_disable, 
Gui, Add, CheckBox, x354 y77 w16 h19 vHeave_prop_disable, 
Gui, Add, CheckBox, x354 y98 w16 h19 vSurge_prop_disable, 
Gui, Add, CheckBox, x354 y118 w16 h19 vSway_prop_disable, 
Gui, Add, CheckBox, x354 y137 w16 h19 vYaw_prop_disable,
Gui, Show, x50 y50 h211 w399, Actuator Stroke Mix Settings
Gui, Cancel


;Initialise associated variables - all reset on software start
Pitch_prop_disable := 0
Roll_prop_disable := 0
Heave_prop_disable := 0
Surge_prop_disable := 0
Sway_prop_disable := 0
Yaw_prop_disable := 0

;The Yaw cue settings window
Gui 8:Default
Gui, Color, Silver
Gui, Add, GroupBox, x6 y4 w390 h256 , Yaw Cue Settings
Gui, Add, Text, x15 y29 w360 h16 , Yaw velocity scaling factors
Gui, Add, Text, x15 y51 w107 h20 , Y1 Vehic On Ground
Gui, Add, Edit, x123 y51 w70 h20 vYaScaleg, 
Gui, Add, Text, x217 y51 w95 h20 , Y2 Vehic In Flight
Gui, Add, Edit, x312 y51 w62 h20 vYaScalea, 
Gui, Add, Text, x15 y87 w360 h20 , Y3 Yaw velocity smoothing/delay filter - Time Constant
Gui, Add, Edit, x305 y85 w30 h20 vTCYa, 
Gui, Add, Text, x345 y87 w30 h20 , s/rad
Gui, Add, Text, x15 y116 w300 h20 , Y4 Raise Yaw velocity above 1.0 rad/s to the power....
Gui, Add, Edit, x320 y114 w40 h20 vYaPw, 
Gui, Add, Text, x15 y145 w190 h20 , Y5 Scaled Yaw velocity cap level
Gui, Add, Edit, x205 y143 w40 h20 vYaSat, 
Gui, Add, Text, x255 y145 w40 h20 , rad/s
Gui, Add, Text, x15 y171 w250 h20 , Y6 Yaw velocity washout filter - Time Constant
Gui, Add, Edit, x265 y169 w40 h20 vTCyp, 
Gui, Add, Text, x315 y171 w30 h20 , s/rad
Gui, Add, Text, x15 y197 w250 h20 , Y7 Yaw cue final smoothing filter - Time Constant
Gui, Add, Edit, x256 y195 w40 h20 vTCyf, 
Gui, Add, Text, x305 y197 w30 h20 , s/rad
Gui, Add, Text, x15 y232 w265 h20 , Y8 Yaw velocity to give full range movement      +/-
Gui, Add, Edit, x287 y230 w40 h20 vYaMax, 
Gui, Add, Text, x335 y232 w40 h20 , rad/s
Gui, Add, Button, x12 y265 w82 h25 , Close
Gui, Add, Button, x164 y266 w82 h25 , Use
Gui, Add, Button, x308 y266 w82 h25 , Save
Gui, Show, x50 y50 h301 w404, Yaw Cue Settings
Gui, Cancel

;Slider based pitch settings
Gui 9:Default
Gui, Color, Silver
Gui, Add, Button, x12 y533 w82 h25 , Close
Gui, Add, Button, x157 y533 w82 h25 , Use
Gui, Add, Button, x303 y533 w82 h25 , Save
Gui, Add, GroupBox, x12 y10 w370 h100 , Pitch and Surge
Gui, Add, Text, x22 y30 w230 h20 , PS1: Pitch/Surge Acceleration Frequency Split
Gui, Add, GroupBox, x12 y385 w370 h140 , Surge Cue
Gui, Add, Text, x22 y73 w40 h30 +Center, Delay Tilt
Gui, Add, Text, x330 y73 w45 h30 +Center, Advance Tilt
Gui, Add, Slider, x15 y50 w360 h25 ToolTipRight vPS1, PS Freq Split
Gui, Add, Text, x22 y130 w200 h20 , PS2: Sensitivity to vehicle acceleration
Gui, Add, Slider, x15 y150 w360 h25 ToolTipRight vPS2, PS Tilt Sensitivity
Gui, Add, Text, x22 y175 w40 h20 +Center, Low
Gui, Add, Text, x332 y175 w40 h20 +Center, High
Gui, Add, Text, x22 y195 w110 h20 , PS3: Washout Rate
Gui, Add, Slider, x132 y195 w200 h25 ToolTipRight vPS3, PS Tilt Washout
Gui, Add, Text, x132 y220 w30 h20 , Slow
Gui, Add, Text, x312 y220 w30 h20 , Fast
Gui, Add, GroupBox, x12 y115 w370 h130 , Pitch Tilt for Acceleration Cue
Gui, Add, Text, x22 y265 w200 h20 , PS4: Sensitivity to vehicle pitch angle
Gui, Add, Slider, x15 y285 w360 h25 ToolTipRight vPS4, PS Pitch Rate Sensitivity
Gui, Add, Text, x22 y310 w40 h20 +Center, Low
Gui, Add, Text, x332 y310 w40 h20 +Center, High
Gui, Add, Text, x22 y335 w110 h20 , PS5: Washout Rate
Gui, Add, Slider, x132 y335 w200 h25 ToolTipRight vPS5, Pitch Rate Washout
Gui, Add, Text, x132 y360 w30 h20 +Center, Slow
Gui, Add, Text, x312 y360 w30 h20 +Center, Fast
Gui, Add, Text, x22 y405 w200 h20 , PS6: Sensitivity to vehicle acceleration
Gui, Add, Slider, x15 y425 w360 h25 ToolTipRight vPS6, PS Surge Sensitivity
Gui, Add, Text, x22 y450 w40 h20 +Center, Low
Gui, Add, Text, x332 y450 w40 h20 +Center, High
Gui, Add, Text, x22 y475 w110 h20 , PS7: Surge Smoothing
Gui, Add, Slider, x132 y475 w200 h25 ToolTipRight vPS7, Surge Smoothing
Gui, Add, Text, x132 y505 w50 h15 +Center, Smoother
Gui, Add, Text, x282 y505 w50 h15 +Center, Sharper
Gui, Add, CheckBox, x332 y190 w30 h30 vPS3_Off, Off
Gui, Add, CheckBox, x332 y325 w30 h40 vPS5_Off, Off
Gui, Add, CheckBox, x332 y470 w30 h30 vPS7_Off, Off
Gui, Add, GroupBox, x12 y250 w370 h130 , Pitch Tilt for Pitch Rate Cue
Gui, Show, x174 y153 h576 w403, Easy Pitch & Surge Cue Settings
Gui, Cancel



;Slider based roll settings
Gui 10:Default
Gui, Color, Silver
Gui, Add, Button, x12 y533 w82 h25 , Close
Gui, Add, Button, x157 y533 w82 h25 , Use
Gui, Add, Button, x303 y533 w82 h25 , Save
Gui, Add, GroupBox, x12 y10 w370 h100 , Roll and Sway
Gui, Add, Text, x22 y30 w230 h20 , RS1: Roll/Sway Acceleration Frequency Split
Gui, Add, GroupBox, x12 y385 w370 h140 , Sway Cue
Gui, Add, Text, x22 y73 w40 h30 +Center, Delay Tilt
Gui, Add, Text, x330 y73 w45 h30 +Center, Advance Tilt
Gui, Add, Slider, x15 y50 w360 h25 ToolTipRight vRS1, RS Freq Split
Gui, Add, Text, x22 y130 w200 h20 , RS2: Sensitivity to vehicle acceleration
Gui, Add, Slider, x15 y150 w360 h25 ToolTipRight vRS2, RS Tilt Sensitivity
Gui, Add, Text, x22 y175 w40 h20 +Center, Low
Gui, Add, Text, x332 y175 w40 h20 +Center, High
Gui, Add, Text, x22 y195 w110 h20 , RS3: Washout Rate
Gui, Add, Slider, x132 y195 w200 h25 ToolTipRight vRS3, RS Tilt Washout
Gui, Add, Text, x132 y220 w30 h20 , Slow
Gui, Add, Text, x312 y220 w30 h20 , Fast
Gui, Add, GroupBox, x12 y115 w370 h130 , Roll Tilt for Acceleration Cue
Gui, Add, Text, x22 y265 w200 h20 , RS4: Sensitivity to vehicle roll angle
Gui, Add, Slider, x15 y285 w360 h25 ToolTipRight vRS4, RS Roll Rate Sensitivity
Gui, Add, Text, x22 y310 w40 h20 +Center, Low
Gui, Add, Text, x332 y310 w40 h20 +Center, High
Gui, Add, Text, x22 y335 w110 h20 , RS5: Washout Rate
Gui, Add, Slider, x132 y335 w200 h25 ToolTipRight vRS5, Roll Rate Washout
Gui, Add, Text, x132 y360 w30 h20 +Center, Slow
Gui, Add, Text, x312 y360 w30 h20 +Center, Fast
Gui, Add, Text, x22 y405 w200 h20 , RS6: Sensitivity to vehicle acceleration
Gui, Add, Slider, x15 y425 w360 h25 ToolTipRight vRS6, RS Sway Sensitivity
Gui, Add, Text, x22 y450 w40 h20 +Center, Low
Gui, Add, Text, x332 y450 w40 h20 +Center, High
Gui, Add, Text, x22 y475 w110 h20 , RS7: Sway Smoothing
Gui, Add, Slider, x132 y475 w200 h25 ToolTipRight vRS7, Sway Smoothing
Gui, Add, Text, x132 y505 w50 h15 +Center, Smoother
Gui, Add, Text, x282 y505 w50 h15 +Center, Sharper
Gui, Add, CheckBox, x332 y190 w30 h30 vRS3_Off, Off
Gui, Add, CheckBox, x332 y325 w30 h40 vRS5_Off, Off
Gui, Add, CheckBox, x332 y470 w30 h30 vRS7_Off, Off
Gui, Add, GroupBox, x12 y250 w370 h130 , Roll Tilt for Roll Rate Cue
Gui, Show, x174 y153 h576 w403, Easy Roll & Sway Cue Settings
Gui, Cancel


;Slider based heave settings
Gui 11:Default
Gui, Color, Silver
Gui, Add, Button, x12 y278 w82 h25 , Close
Gui, Add, Button, x157 y278 w82 h25 , Use
Gui, Add, Button, x303 y278 w82 h25 , Save
Gui, Add, GroupBox, x12 y10 w370 h260 , Heave Cue
Gui, Add, Text, x22 y30 w230 h20 , HS1: Raw vertical acceleration smoothing
Gui, Add, Slider, x132 y50 w200 h25  ToolTipRight vHS1, Raw Accel Smoothing
Gui, Add, Text, x132 y73 w50 h15 , Smoother
Gui, Add, Text, x282 y73 w50 h15 , Sharper
Gui, Add, Text, x22 y90 w210 h20 , HS2: Cue sensitivity to vehicle acceleration
Gui, Add, Slider, x15 y110 w360 h25 ToolTipRight vHS2, HS Heave Sensitivity
Gui, Add, Text, x22 y135 w40 h20 +Center, Low
Gui, Add, Text, x332 y135 w40 h20 +Center, High
Gui, Add, Text, x22 y155 w110 h20 , HS3: Washout Rate
Gui, Add, Slider, x132 y155 w200 h25 ToolTipRight vHS3, HS Heave Washout
Gui, Add, Text, x132 y180 w30 h20 , Slow
Gui, Add, Text, x312 y180 w30 h20 , Fast
Gui, Add, Text, x22 y200 w160 h20 , HS4: Final heave cue smoothing
Gui, Add, Slider, x132 y220 w200 h25 ToolTipRight vHS4, Final Heave Smoothing
Gui, Add, Text, x132 y250 w50 h15 +Center, Smoother
Gui, Add, Text, x282 y250 w50 h15 +Center, Sharper
Gui, Add, CheckBox, x332 y45 w30 h30 vHS1_Off, Off
Gui, Add, CheckBox, x332 y150 w30 h30 vHS3_Off, Off
Gui, Add, CheckBox, x332 y215 w30 h30 vHS4_Off, Off
Gui, Show, x174 y153 h315 w396, Easy Heave Cue Settings
Gui, Cancel


;Slider based yaw settings
Gui 12:Default
Gui, Color, Silver
Gui, Add, Button, x12 y278 w82 h25 , Close
Gui, Add, Button, x157 y278 w82 h25 , Use
Gui, Add, Button, x303 y278 w82 h25 , Save
Gui, Add, GroupBox, x12 y10 w370 h260 , Yaw Cue
Gui, Add, Text, x22 y30 w230 h20 , YS1: Raw yaw velocity smoothing
Gui, Add, Slider, x132 y50 w200 h25  ToolTipRight vYS1, Raw Vel Smoothing
Gui, Add, Text, x132 y73 w50 h15 , Smoother
Gui, Add, Text, x282 y73 w50 h15 , Sharper
Gui, Add, Text, x22 y90 w210 h20 , YS2: Cue sensitivity to vehicle yaw rate
Gui, Add, Slider, x15 y110 w360 h25 ToolTipRight vYS2, YS Yaw Sensitivity
Gui, Add, Text, x22 y135 w40 h20 +Center, Low
Gui, Add, Text, x332 y135 w40 h20 +Center, High
Gui, Add, Text, x22 y155 w110 h20 , YS3: Washout Rate
Gui, Add, Slider, x132 y155 w200 h25 ToolTipRight vYS3, HS Yaw Washout
Gui, Add, Text, x132 y180 w30 h20 , Slow
Gui, Add, Text, x312 y180 w30 h20 , Fast
Gui, Add, Text, x22 y200 w160 h20 , YS4: Final yaw cue smoothing
Gui, Add, Slider, x132 y220 w200 h25 ToolTipRight vYS4, Final Yaw Smoothing
Gui, Add, Text, x132 y250 w50 h15 +Center, Smoother
Gui, Add, Text, x282 y250 w50 h15 +Center, Sharper
Gui, Add, CheckBox, x332 y45 w30 h30 vYS1_Off, Off
Gui, Add, CheckBox, x332 y150 w30 h30 vYS3_Off, Off
Gui, Add, CheckBox, x332 y215 w30 h30 vYS4_Off, Off
Gui, Show, x174 y153 h315 w396, Easy Yaw Cue Settings
Gui, Cancel


;Data display window

Gui 14:Default
Gui, Color, Silver
Gui, Add, GroupBox, x4 y4 w259 h347 , Incoming TCP Data
Gui, Add, Edit, x13 y21 w241 h319 vData_Text -VScroll, No Data....
Gui, Show, x152 y139 h362 w271, TCP Data
Gui, Cancel



Gui 1:Default

IfNotExist, BFF_License.txt
	{
  MsgBox, License file not found.....program will close.
	ExitApp
	}

GuiControl, Disable, Hold_Start_Pos
GuiControl, Disable, _Drive
;GuiControl, Disable, Start_PID_Controller
GuiControl, Disable, Re_Load
GuiControl, Disable, Re_Set
GuiControl, Disable, Slider_H
GuiControl, Disable, Slider_V
GuiControl, Disable, Slider_T
GuiControl, Disable, Scale_H
GuiControl, Disable, Scale_V
GuiControl, Disable, Scale_T
GuiControl, Disable, Enable_Vis
GuiControl, Disable, Manual_Override
GuiControl, Disable, ACT_DOF
;GuiControl, Disable, P
;GuiControl, Disable, R
;GuiControl, Disable, H
;GuiControl, Disable, Y
;GuiControl, Disable, M
GuiControl, Disable, Capture
GuiControl, Disable, S1
GuiControl, Disable, S2
GuiControl, Disable, S3

icapt := 0
DMC_Active := 0
DMC_Parked := 1
iscope := 0
ishow := 0
v_Mode := "NONE"

;Check if start is automated
IniRead, Auto_Start, Start.ini, Auto_Start, Auto_Start, No
IniRead, Auto_Start_Delay, Start.ini, Auto_Start, Auto_Start_Delay, 1000

if (Auto_Start = "Yes")
{
  GuiControl,, MyText, Auto-Starting after %Auto_Start_Delay% ms....
  FileAppend, `n Auto-Starting after %Auto_Start_Delay% ms....`n`n, 6DOF.log
	Sleep, %Auto_Start_Delay%
  Goto ButtonStart
}

return

;Include SWP functions
#Include SWProtect-GUI_5.ahk

;Include the Easy settings widow functions
#Include Slider_Settings3.ahk


;=================================================================
;Scope Button 1
;=================================================================

ButtonS1:

if iscope1 = 0
  {
  iscope1 := 1
  Scope_Init1 := 0
  GuiControl, Disable, S2
  GuiControl, Disable, S3
  }
else
  {
  iscope1 := 0
  rc := DllCall("Osc_DLL\ScopeDestroy", Int, hScope1, "Cdecl Int")
  GuiControl, Enable, S2
  GuiControl, Enable, S3
  }

return



;=================================================================
;Scope Button 2
;=================================================================

ButtonS2:

if iscope2 = 0
  {
  iscope2 := 1
  Scope_Init2 := 0
  GuiControl, Disable, S1
  GuiControl, Disable, S3
  }
else
  {
  iscope2 := 0
  rc := DllCall("Osc_DLL\ScopeDestroy", Int, hScope2, "Cdecl Int")
  GuiControl, Enable, S1
  GuiControl, Enable, S3
  }

return



;=================================================================
;Scope Button 3
;=================================================================

ButtonS3:

if iscope3 = 0
  {
  iscope3 := 1
  Scope_Init3 := 0
  GuiControl, Disable, S1
  GuiControl, Disable, S2
  }
else
  {
  iscope3 := 0
  rc := DllCall("Osc_DLL\ScopeDestroy", Int, hScope3, "Cdecl Int")
  GuiControl, Enable, S1
  GuiControl, Enable, S2
  }

return


;=================================================================
;Info Button
;=================================================================

ButtonInfo:

if ishow = 0
  {
  Gui, 1:Show, h540 w463
  ishow := 1
  }
else
  {
  Gui, 1:Show, h444 w463
  ishow := 0  
  }

return

;=================================================================
;Show the actuator mix settings window
;=================================================================

ButtonM:

iDrive := 0
SetTitleMatchMode, 1
WinGetPos, posx, posy, , , BFF 6-DOF Platform Motion Driver
posx += 30
posy += 400
GUI, 7:Show, x%posx% y%posy%
GUI, 7:-SysMenu
GuiControl, 7: Disable, Save

GUI, 4:Cancel
GUI, 5:Cancel
GUI, 6:Cancel
GUI, 8:Cancel

GuiControl, 7:, Pitch_prop ,%Pitch_prop%
GuiControl, 7:, Roll_prop ,%Roll_prop%
GuiControl, 7:, Heave_prop ,%Heave_prop%
GuiControl, 7:, Surge_prop ,%Surge_prop%
GuiControl, 7:, Sway_prop ,%Sway_prop%
GuiControl, 7:, Yaw_prop ,%Yaw_prop%

GuiControl, 7:, Pitch_Rev ,%Pitch_Rev%
GuiControl, 7:, Roll_Rev ,%Roll_Rev%
GuiControl, 7:, Heave_Rev ,%Heave_Rev%
GuiControl, 7:, Surge_Rev ,%Surge_Rev%
GuiControl, 7:, Sway_Rev ,%Sway_Rev%
GuiControl, 7:, Yaw_Rev ,%Yaw_Rev%

GuiControl, 7:, Pitch_prop_disable ,%Pitch_prop_disable%
GuiControl, 7:, Roll_prop_disable ,%Roll_prop_disable%
GuiControl, 7:, Heave_prop_disable ,%Heave_prop_disable%
GuiControl, 7:, Surge_prop_disable ,%Surge_prop_disable%
GuiControl, 7:, Sway_prop_disable ,%Sway_prop_disable%
GuiControl, 7:, Yaw_prop_disable ,%Yaw_prop_disable%

WinActivate, Actuator Stroke Mix Settings


return


;=================================================================
;Close the cue settings windows
;=================================================================

4ButtonClose:
5ButtonClose:
6ButtonClose:
7ButtonClose:
8ButtonClose:
9ButtonClose:
10ButtonClose:
11ButtonClose:
12ButtonClose:

;iDrive := 0

GUI, 4:Cancel
GUI, 5:Cancel
GUI, 6:Cancel
GUI, 7:Cancel
GUI, 8:Cancel
GUI, 9:Cancel
GUI, 10:Cancel
GUI, 11:Cancel
GUI, 12:Cancel

return



;=================================================================
;Use new pitch settings
;=================================================================

4ButtonUse:

iDrive := 0

pFaScaleg := FaScaleg
pFaScalea := FaScalea
pTCfg := TCfg
pTCfa := TCfa
pFaCap := FaCap
pRateP := RateP
pTCpr := TCpr
pTCpa := TCpa
pFAMax := FAMax

pTCSUg := TCSUg
pTCSUa := TCSUa
pSUaCap := SUaCap
pTCSU1g := TCSU1g
pTCSU1a := TCSU1a
pSUaMax := SUaMax

GuiControlGet, FaScaleg, 4:
GuiControlGet, FaScalea, 4:
GuiControlGet, TCfg, 4:
GuiControlGet, TCfa, 4:
GuiControlGet, FaCap, 4:
GuiControlGet, RateP, 4:
GuiControlGet, TCpr, 4:
GuiControlGet, TCpa, 4:
GuiControlGet, FAMax, 4:

GuiControlGet, TCSUg, 4:
GuiControlGet, TCSUa, 4:
GuiControlGet, SUaCap, 4:
GuiControlGet, TCSU1g, 4:
GuiControlGet, TCSU1a, 4:
GuiControlGet, SUaMax, 4:

;FAMax := ASin(FaCap / 9.81)
SUaCap := SUaMax

W_err := 0
if FaScaleg is not number
  W_err := 1
if FaScalea is not number
  W_err := 1
if TCfg is not number
  W_err := 1
if TCfa is not number
  W_err := 1  
if FaCap is not number
  W_err := 1
if RateP is not number
  W_err := 1
if TCpr is not number
  W_err := 1
if TCpa is not number
  W_err := 1
if FAMax is not number
  W_err := 1
  
if TCSUg is not number
  W_err := 1  
if TCSUa is not number
  W_err := 1
if SUaCap is not number
  W_err := 1
if TCSU1g is not number
  W_err := 1
if TCSU1a is not number
  W_err := 1
if SUaMax is not number
  W_err := 1
  
if (W_Err != 0)
  {
    MsgBox, WARNING.. One of the settings is not a number!
    FaScaleg := pFaScaleg
    FaScalea := pFaScalea
    TCfg := pTCfg
    TCfa := pTCfa
    FaCap := pFaCap
    RateP := pRateP
    TCpr := pTCpr
    TCpa := pTCpa
    FAMax := pFAMax
    
    TCSUg := pTCSUg
    TCSUa := pTCSUa
    SUaCap := pSUaCap
    TCSU1g := pTCSU1g
    TCSU1a := pTCSU1a
    SUaMax := pSUaMax
    Return
  }

GuiControl, 4:, SUaCap ,%SUaCap%  

Sleep, 500
MsgBox, Settings loaded.....

GuiControl, 4: Enable, Save

;GUI, 4:Cancel

return

;=================================================================
;Use new roll settings
;=================================================================

5ButtonUse:

iDrive := 0

pLaScaleg := LaScaleg
pLaScalea := LaScalea
pTCllg := TCllg
pTClla := TClla
pLaCap := LaCap
pRateF := RateF
pTCl := TCl
pTCla := TCla
pLAMax := LAMax

pTCSWg := TCSWg
pTCSWa := TCSWa
pSWaCap := SWaCap
pTCSW1g := TCSW1g
pTCSW1a := TCSW1a
pSWaMax := SWaMax

GuiControlGet, LaScaleg, 5:
GuiControlGet, LaScalea, 5:
GuiControlGet, TCllg, 5:
GuiControlGet, TClla, 5:
GuiControlGet, LaCap, 5:
GuiControlGet, RateF, 5:
GuiControlGet, TCl, 5:
GuiControlGet, TCla, 5:
GuiControlGet, LaMax, 5:

GuiControlGet, TCSWg, 5:
GuiControlGet, TCSWa, 5:
GuiControlGet, SWaCap, 5:
GuiControlGet, TCSW1g, 5:
GuiControlGet, TCSW1a, 5:
GuiControlGet, SWaMax, 5:

SWaCap := SWaMax

W_err := 0
if LaScaleg is not number
  W_err := 1
if LaScalea is not number
  W_err := 1
if TCllg is not number
  W_err := 1
if TClla is not number
  W_err := 1  
if LaCap is not number
  W_err := 1
if RateF is not number
  W_err := 1
if TCl is not number
  W_err := 1
if TCla is not number
  W_err := 1
if LaMax is not number
  W_err := 1
  
if TCSWg is not number
  W_err := 1  
if TCSWa is not number
  W_err := 1
if SWaCap is not number
  W_err := 1
if TCSW1g is not number
  W_err := 1
if TCSW1a is not number
  W_err := 1
if SWaMax is not number
  W_err := 1
  
if (W_Err != 0)
  {
    MsgBox, WARNING.. One of the settings is not a number!
    LaScaleg := pLaScaleg
    LaScalea := pLaScalea
    TCllg := pTCllg
    TClla := pTClla
    LaCap := pLaCap
    RateF := pRateF
    TCl := pTCl
    TCla := pTCla
    LAMax := pLAMax
    
    TCSWg := pTCSWg
    TCSWa := pTCSWa
    SWaCap := pSWaCap
    TCSW1g := pTCSW1g
    TCSW1a := pTCSW1a
    SWaMax := pSWaMax
    Return
  }

GuiControl, 5:, SWaCap ,%SWaCap%
  
Sleep, 500
MsgBox, Settings loaded.....

GuiControl, 5: Enable, Save

;GUI, 5:Cancel

return

;=================================================================
;Use new heave settings
;=================================================================

6ButtonUse:

iDrive := 0

pVaScaleg := VaScaleg
pVaScalea := VaScalea
pTCva := TCva
pVaPw := VaPw
pVaSat := VaSat
pTCvp := TCvp
pTCvf := TCvf
pVaMax := VaMax
pTurb_Scalea := Turb_Scalea
pTurb_Scaleg := Turb_Scaleg

GuiControlGet, VaScaleg, 6:
GuiControlGet, VaScalea, 6:
GuiControlGet, TCva, 6:
GuiControlGet, VaPw, 6:
GuiControlGet, VaSat, 6:
GuiControlGet, TCvp, 6:
GuiControlGet, TCvf, 6:
GuiControlGet, VaMax, 6:
GuiControlGet, Turb_Scalea, 6:
GuiControlGet, Turb_Scaleg, 6:

VaSat := VaMax

W_err := 0
if VaScaleg is not number
  W_err := 1
if VaScalea is not number
  W_err := 1
if TCva is not number
  W_err := 1
if VaPw is not number
  W_err := 1  
if VaSat is not number
  W_err := 1
if TCvp is not number
  W_err := 1
if TCvf is not number
  W_err := 1
if VaMax is not number
  W_err := 1
if Turb_Scalea is not number
  W_err := 1
if Turb_Scaleg is not number
  W_err := 1
  
if (W_Err != 0)
  {
    MsgBox, WARNING.. One of the settings is not a number!
    VaScaleg := pVaScaleg
    VaScalea := pVaScalea
    TCva := pTCva
    VaPw := pVaPw
    VaSat := pVaSat
    TCvp := pTCvp
    TCvf := pTCvf
    VaMax := pVaMax
    Turb_Scalea := pTurb_Scalea
    Turb_Scaleg := pTurb_Scaleg
    Return
  }
  
GuiControl, 6:, VaSat ,%VaSat%

Sleep, 500
MsgBox, Settings loaded.....

GuiControl, 6: Enable, Save

;GUI, 6:Cancel

return



;=================================================================
;Use new yaw settings
;=================================================================

8ButtonUse:

iDrive := 0

pYaScaleg := YaScaleg
pYaScalea := YaScalea
pTCya := TCya
pYaPw := YaPw
pYaSat := YaSat
pTCyp := TCyp
pTCyf := TCyf
pYaMax := YaMax

GuiControlGet, YaScaleg, 8:
GuiControlGet, YaScalea, 8:
GuiControlGet, TCya, 8:
GuiControlGet, YaPw, 8:
GuiControlGet, YaSat, 8:
GuiControlGet, TCyp, 8:
GuiControlGet, TCyf, 8:
GuiControlGet, YaMax, 8:

YaSat := YaMax

W_err := 0
if YaScaleg is not number
  W_err := 1
if YaScalea is not number
  W_err := 1
if TCya is not number
  W_err := 1
if YaPw is not number
  W_err := 1  
if YaSat is not number
  W_err := 1
if TCyp is not number
  W_err := 1
if TCyf is not number
  W_err := 1
if YaMax is not number
  W_err := 1
  
if (W_Err != 0)
  {
    MsgBox, WARNING.. One of the settings is not a number!
    YaScaleg := pYaScaleg
    YaScalea := pYaScalea
    TCya := pTCya
    YaPw := pYaPw
    YaSat := pYaSat
    TCyp := pTCyp
    TCyf := pTCyf
    YaMax := pYaMax
    Return
  }
  
GuiControl, 8:, YaSat ,%YaSat%

Sleep, 500
MsgBox, Settings loaded.....

GuiControl, 8: Enable, Save

;GUI, 6:Cancel

return


;=================================================================
;Use new actuator mix settings
;=================================================================

7ButtonUse:

iDrive := 0

pPitch_prop := Pitch_prop
pRoll_prop := Roll_prop
pHeave_prop := Heave_prop
pSurge_prop := Surge_prop
pSway_prop := Sway_prop
pYaw_prop := Yaw_prop

GuiControlGet, Pitch_prop, 7:
GuiControlGet, Roll_prop, 7:
GuiControlGet, Heave_prop, 7:
GuiControlGet, Surge_prop, 7:
GuiControlGet, Sway_prop, 7:
GuiControlGet, Yaw_prop, 7:


GuiControlGet, Pitch_Rev, 7:
GuiControlGet, Roll_Rev, 7:
GuiControlGet, Heave_Rev, 7:
GuiControlGet, Surge_Rev, 7:
GuiControlGet, Sway_Rev, 7:
GuiControlGet, Yaw_Rev, 7:


GuiControlGet, Pitch_prop_disable, 7:
GuiControlGet, Roll_prop_disable, 7:
GuiControlGet, Heave_prop_disable, 7:
GuiControlGet, Surge_prop_disable, 7:
GuiControlGet, Sway_prop_disable, 7:
GuiControlGet, Yaw_prop_disable, 7:

W_err := 0
if Pitch_prop is not number
  W_err := 1
if Roll_prop is not number
  W_err := 1
if Heave_prop is not number
  W_err := 1
if Surge_prop is not number
  W_err := 1
if Sway_prop is not number
  W_err := 1
if Yaw_prop is not number
  W_err := 1
  
if (W_Err != 0)
  {
    MsgBox, WARNING.. One of the settings is not a number!
    Pitch_prop := pPitch_prop
    Roll_prop := pRoll_prop
    Heave_prop := pHeave_prop
    Surge_prop := pSurge_prop
    Sway_prop := pSway_prop
    Yaw_prop := pYaw_prop
    Return
  }

if Pitch_prop > 100
  Pitch_prop := 100
else if Pitch_prop < 0
  Pitch_prop := 0

if Heave_prop > 100
  Heave_prop := 100
else if Heave_prop < 0
  Heave_prop := 0
  
if Heave_prop > 100
  Heave_prop := 100
else if Heave_prop < 0
  Heave_prop := 0
  
if Surge_prop > 100
  Surge_prop := 100
else if Surge_prop < 0
  Surge_prop := 0

if Sway_prop > 100
  Sway_prop := 100
else if Sway_prop < 0
  Sway_prop := 0
  
if Yaw_prop > 100
  Yaw_prop := 100
else if Yaw_prop < 0
  Yaw_prop := 0
  
GuiControl, 7:, Pitch_prop ,%Pitch_prop%
GuiControl, 7:, Roll_prop ,%Roll_prop%
GuiControl, 7:, Heave_prop ,%Heave_prop%
GuiControl, 7:, Surge_prop ,%Surge_prop%
GuiControl, 7:, Sway_prop ,%Sway_prop%
GuiControl, 7:, Yaw_prop ,%Yaw_prop%

Sleep, 1000
MsgBox, Settings loaded..... ;%Pitch_prop% %Roll_prop% %Heave_prop%

GuiControl, 7: Enable, Save

;GUI, 6:Cancel

return

;=================================================================
;Save the cue settings
;=================================================================

4ButtonSave:
5ButtonSave:
6ButtonSave:
7ButtonSave:
8ButtonSave:
9ButtonSave:
10ButtonSave:
11ButtonSave:
12ButtonSave:

GuiControl, 4: Disable, Close
GuiControl, 5: Disable, Close
GuiControl, 6: Disable, Close
GuiControl, 7: Disable, Close
GuiControl, 8: Disable, Close
GuiControl, 9: Disable, Close
GuiControl, 10: Disable, Close
GuiControl, 11: Disable, Close
GuiControl, 12: Disable, Close

if (FileName = )
  {
    MsgBox, No config file loaded yet......
    return
  }
iret := save_config_part(FileName)
  if iret
  {
    MsgBox, Error %iret% saving to config file %FileName%
    Goto Finish
  }
Sleep, 1000
MsgBox, Settings saved to...`n%FileName%

GuiControl, 4: Enable, Close
GuiControl, 5: Enable, Close
GuiControl, 6: Enable, Close
GuiControl, 7: Enable, Close
GuiControl, 8: Enable, Close
GuiControl, 9: Enable, Close
GuiControl, 10: Enable, Close
GuiControl, 11: Enable, Close
GuiControl, 12: Enable, Close

return


;=================================================================
;Show the Manual Override window
;=================================================================

ButtonManual_Override:

;Read the act/DOF check box
GuiControlGet, ACT_DOF, 1:
if (ACT_DOF = 1 AND iDrive = 0)
  {
    MsgBox, DRIVE mode must be enabled before Manual Override by DOF is activated.
    Return
  }
;Disable the check box
GuiControl, 1: Disable, ACT_DOF

;Disable the Together button if by DOF
GuiControl, 3: Enable, Together
if (ACT_DOF = 1)
  GuiControl, 3: Disable, Together

SetTitleMatchMode, 1
WinGetPos, posx, posy, , , BFF 6-DOF Platform Motion Driver
posx += 0
posy += 400

;Set the slider scales
if (ACT_DOF = 1)
{
  Range := (FALim_r_1 * 10) "-" (FALim_r_2 * 10)
  GuiControl, 3: +Range%Range%, man_pos1
  Range := (LALim_r_1 * 10) "-" (LALim_r_2 * 10)	
  GuiControl, 3: +Range%Range%, man_pos2
  Range := VALim_r_1 "-" VALim_r_2	
  GuiControl, 3: +Range%Range%, man_pos3
  Range := SUALim_r_1 "-" SUALim_r_2
  GuiControl, 3: +Range%Range%, man_pos4
  Range := SWALim_r_1 "-" SWALim_r_2	
  GuiControl, 3: +Range%Range%, man_pos5
  Range := (YaLim_r_1 * 10) "-" (YALim_r_2 * 10)	
  GuiControl, 3: +Range%Range%, man_pos6
  ;MsgBox, %Range% : %YALim_r_1% : %YALim_r_2%
}
else
{
  GuiControl, +Range0-255, man_pos1
  GuiControl, +Range0-255, man_pos2
  GuiControl, +Range0-255, man_pos3
  GuiControl, +Range0-255, man_pos4
  GuiControl, +Range0-255, man_pos5
  GuiControl, +Range0-255, man_pos6
}

i_manual := 1
;Set the sliders to the current position demand outputs
if (ACT_DOF = 1)
{
pos_init := iFASmooths * 10                 ;scale the angle unit DOF's for better smoothness of adjustment
GuiControl, 3:, man_pos1, %pos_init%
pos_init := iLASmooths * 10
GuiControl, 3:, man_pos2, %pos_init%
GuiControl, 3:, man_pos3, %iVASmooths%
GuiControl, 3:, man_pos4, %iSUASmooths%
GuiControl, 3:, man_pos5, %iSWASmooths%
pos_init := iYASmooths * 10
GuiControl, 3:, man_pos6, %pos_init%
}
else
{
GuiControl, 3:, man_pos1, %iFASmooth2%
GuiControl, 3:, man_pos2, %iLASmooth2%
GuiControl, 3:, man_pos3, %iVASmooth2%
GuiControl, 3:, man_pos4, %iSUASmooth2%
GuiControl, 3:, man_pos5, %iSWASmooth2%
GuiControl, 3:, man_pos6, %iYASmooth2%
}

GUI, 3:Show, x%posx% y%posy%
GUI, 3:-SysMenu

return


;=================================================================
;Close the Manual Override window
;=================================================================

3ButtonClose:

;Disable the sliders
GuiControl, 3: Disable, man_pos1
GuiControl, 3: Disable, man_pos2
GuiControl, 3: Disable, man_pos3
GuiControl, 3: Disable, man_pos4
GuiControl, 3: Disable, man_pos5
GuiControl, 3: Disable, man_pos6
;Uncheck the boxes
GuiControl, 3:, Enable_1, 0
GuiControl, 3:, Enable_2, 0
GuiControl, 3:, Enable_3, 0
GuiControl, 3:, Enable_4, 0
GuiControl, 3:, Enable_5, 0
GuiControl, 3:, Enable_6, 0
GuiControl, 3:, Together, 0
;Set the drive to Hold
iDrive := 0
;Enable the check box
GuiControl, 1: Enable, ACT_DOF

GUI, 3:Cancel
i_manual := 0
i_Together := 0

return


;=================================================================
;Manual Override Enable 1
;=================================================================

Enable_1:

GuiControlGet, Enable_1, 3:
if (Enable_1 = 1)
  GuiControl, 3: Enable, man_pos1
else
  GuiControl, 3: Disable, man_pos1

return


;=================================================================
;Manual Override Enable 2
;=================================================================

Enable_2:

GuiControlGet, Enable_2, 3:
if (Enable_2 = 1)
  GuiControl, 3: Enable, man_pos2
else
  GuiControl, 3: Disable, man_pos2

return

;=================================================================
;Manual Override Enable 3
;=================================================================

Enable_3:

GuiControlGet, Enable_3, 3:
if (Enable_3 = 1)
  GuiControl, 3: Enable, man_pos3
else
  GuiControl, 3: Disable, man_pos3

return

;=================================================================
;Manual Override Enable 4
;=================================================================

Enable_4:

GuiControlGet, Enable_4, 3:
if (Enable_4 = 1)
  GuiControl, 3: Enable, man_pos4
else
  GuiControl, 3: Disable, man_pos4

return

;=================================================================
;Manual Override Enable 5
;=================================================================

Enable_5:

GuiControlGet, Enable_5, 3:
if (Enable_5 = 1)
  GuiControl, 3: Enable, man_pos5
else
  GuiControl, 3: Disable, man_pos5

return

;=================================================================
;Manual Override Enable 6
;=================================================================

Enable_6:

GuiControlGet, Enable_6, 3:
if (Enable_6 = 1)
  GuiControl, 3: Enable, man_pos6
else
  GuiControl, 3: Disable, man_pos6

return

;=================================================================
;Manual Override Move together
;=================================================================

Together:

GuiControlGet, Together, 3:

if (Together = 1)
  {
    i_Together := 1
    GuiControlGet, man_pos1, 3:
    GuiControlGet, man_pos2, 3:
    GuiControlGet, man_pos3, 3:
    GuiControlGet, man_pos4, 3:
    GuiControlGet, man_pos5, 3:
    GuiControlGet, man_pos6, 3:
    man_pos1_prev := man_pos_1
    man_pos2_prev := man_pos_2
    man_pos3_prev := man_pos_3
    man_pos4_prev := man_pos_4
    man_pos5_prev := man_pos_5
    man_pos6_prev := man_pos_6
  }
else
  i_Together := 0
;MsgBox, Togther %Together% %i_Together%
return



;=================================================================
;Show the Data Capture window
;=================================================================

ButtonCapture:

SetTitleMatchMode, 1
WinGetPos, posx, posy, , , BFF 6-DOF Platform Motion Driver
posx += 30
posy += 450

Fwd1 := 0
Fwd2 := 0
L1 := 0
L2 := 0
V1 := 0
V2 := 0
P1 := 0
P2 := 0
B1a := 0
B2a := 0
Y1 := 0
Y2 := 0

GUI, 2:Show, x%posx% y%posy%
GUI, 2:-SysMenu

icapt := 1

return


;=================================================================
;Reset the Data Capture window
;=================================================================

2ButtonRe_Set:

Fwd1 := 0
Fwd2 := 0
L1 := 0
L2 := 0
V1 := 0
V2 := 0
P1 := 0
P2 := 0
B1a := 0
B2a := 0
Y1 := 0
Y2 := 0

return


;=================================================================
;Close the Data Capture window
;=================================================================

2ButtonClose:

GUI, 2:Cancel
icapt := 0

return


;
;============
;Launch the PID Controller
;============
;

ButtonDisp_Data:

if (Disp_Data != 1) ;display data window
{
  
  SetTitleMatchMode, 1
  WinGetPos, posx, posy, , , BFF 6-DOF Platform Motion Driver
  posx += 30
  posy += 450
  GUI, 14:Show, x%posx% y%posy%
  GUI, 14:-SysMenu

  Disp_Data := 1
}
else  ;hide display window
{
  GUI, 14:Cancel
  Disp_Data := 0
}

return

;
;============
;Launch Web Site
;============
;

LaunchBFF:
Run, http://bffsimulation.com,, UseErrorLevel
return

;
;============
;Launch License
;============
;

LaunchLicense:
Run, notepad.exe BFF_License.txt,, UseErrorLevel
return

;
;============
;_Drive Button
;============
;

Button_Drive:
iDrive := 1
Crashed_Flag := 0
Flight_Int := 0
Just_Started := 0
DllCall("QueryPerformanceCounter", "Int64*", T_Now_D)
T_Drive := T_Now_D * 1.0 / aaCal

;MsgBox iDrive %iDrive%
return

;
;============
;Hold_Start_Pos Button
;============
;

ButtonHold_Start_Pos:
iDrive := 0 
;MsgBox iDrive %iDrive%
return



;
;============
;Run on Start
;============
;

ButtonStart:
;
; Do the registration checks
;

iret := Reg_Check()
if (iret = 1)
  Goto Finish

;
;==========================================================================
;Read the Config File and then do the comms initialisations
;==========================================================================
;

Continue_Init:

IniRead, Config_File, Start.ini, Config, Config_File

if (Config_File = "NONE")
{
  GuiControl,, MyText, Please select the driver configuration file
  if Regtxt_active
    GuiControl,13:,RegTxt2, Please select the driver configuration file.....
  FileSelectFile, FileName, 3, , Please select the driver configuration file to open..., Driver Config File (*.bff)
  if FileName =
    {
    MsgBox, File open cancelled... no file selected. Closing driver........
    Sleep, 1000
    ExitApp
  	}
}
else
{
  FileName := Config_File
  ;MsgBox %FileName% : %Config_File%
  IfNotExist, %FileName%
  {
    MsgBox, The .bff configuration file from Start.ini does not exist... %FileName%
    ExitApp
  }
}

;FileName = BFF-Config.txt

GuiControl,, MyProgress, 5
GuiControl,, MyText, Reading configuration settings from %FileName%

if Regtxt_active
  GuiControl,13:,RegTxt2, Reading configuration settings....

Sleep, 250
iret := set_config(FileName)
if iret
  Goto Finish

;Check that the configuration file is for V3 of the driver

if (Drvr_Rev != 3)
  {
    MsgBox, The selected configuration file is not set up for V3 of the Driver.`nPlease modify a V3 default config file with your settings and try again....
    Sleep, 1000
	  Goto Finish
  }

;If the setup is for a 6-point hexapod coupled platform then redefine the internal variables

if (Rig_Type = 4 OR Rig_Type = 5)
  {
;Check if config file has been prepared with v1.6 setup or later    

    if (VALim2 != "000")   
      {
        MsgBox, This 3-point platform configuration file has not been set up by Driver-Setup-3pt.exe`nRestart with another config file.
	      Sleep, 1000
	      Goto Finish
      }     
    
;Setup the new variables
    Act1_mid := PitchStart      ;Actuator mid positions
    Act2_mid := RollStart
    Act3_mid := HeaveStart
    
    Act4_mid := SurgeStart
    Act5_mid := SwayStart
    Act6_mid := YawStart
    
    Act_Range := FALim1         ;Actuator stroke length in 0-255 scale
    Act_amp_255 := Act_Range / 2.0
    
    Pitch_prop := FALim2        ;Mix proportions for DOF's
    Roll_prop := LALim1
    Heave_prop := LALim2
    
    Surge_prop := SU_prop
    Sway_prop := SW_prop
    Yaw_prop := Yaw_prop
    
    Start_Height := VALim1 / 100
    
;Restore the internal working variables
    FALim1 := Act1_mid - (Act_Range / 2)      ;Actuator min and max limits in 0-255 range
    FALim2 := Act1_mid + (Act_Range / 2)
    
    LALim1 := Act2_mid - (Act_Range / 2)
    LALim2 := Act2_mid + (Act_Range / 2)
    
    VALim1 := Act3_mid - (Act_Range / 2)
    VALim2 := Act3_mid + (Act_Range / 2)
    
    SUALim1 := Act4_mid - (Act_Range / 2)
    SUALim2 := Act4_mid + (Act_Range / 2)
    
    SWALim1 := Act5_mid - (Act_Range / 2)
    SWALim2 := Act5_mid + (Act_Range / 2)
    
    YALim1 := Act6_mid - (Act_Range / 2)
    YALim2 := Act6_mid + (Act_Range / 2)
    
    PitchStart := Round( FALim1 + (Start_Height * Act_Range), 0)      ;Actuator start positions
      
    if (Rig_Type = 5)  ;if handed actuators - start position is calculated from the "other" end
      RollStart := Round( LALim2 - (Start_Height * Act_Range), 0)
    else
      RollStart := Round( LALim1 + (Start_Height * Act_Range), 0)
      
    HeaveStart := Round( VALim1 + (Start_Height * Act_Range), 0)
    
    if (Rig_Type = 5)      
      SurgeStart := Round( SUALim2 - (Start_Height * Act_Range), 0)
    else
      SurgeStart := Round( SUALim1 + (Start_Height * Act_Range), 0)
      
    SwayStart := Round( SWALim1 + (Start_Height * Act_Range), 0)
    
    if (Rig_Type = 5)  
      YawStart := Round( YALim2 - (Start_Height * Act_Range), 0)
    else
      YawStart := Round( YALim1 + (Start_Height * Act_Range), 0)
    
    ;MsgBox %PitchStart%: %RollStart%: %HeaveStart%: %SurgeStart%: %SwayStart%: %YawStart%

;Crank arm actuator variables

    Cranked := "No"
    if (Crank_Radius != 0)
    {
      Cranked := "Yes"
      
      Crank_Rot_Rad := 2 * ASin(Act_Stroke / 2.0 / Crank_Radius)  ;crank angle in radians to give specified stroke
      Crank_Rot_Deg := Crank_Rot_Rad * 360.0 / 2 / pi
      Crank_T1 := -1 * Crank_Rot_Rad / 2.0
      Crank_T2 := Crank_Rot_Rad / 2.0
      
      ;Crank_Radius := Act_Stroke / 2.0 / sin(Crank_T2)      ;crank radius in mm to give specified actuator linear stroke
      
      ;MsgBox, Crank Details... %Crank_Rot_Rad% : %Crank_Rot_Deg% : %Crank_T1% : %Crank_T2% : %Crank_Radius% : %Act_Stroke%
    }
  
;Set up the hexapod and actuator movement ranges

    HXP_Limits()
    ;MsgBox %FaLim_r_1%:%FaLim_r_2%:%LaLim_r_1%:%LaLim_r_2%:%VaLim_r_1%:%VaLim_r_2%:%SUaLim_r_1%:%SUaLim_r_2%:%SWaLim_r_1%:%SWaLim_r_2%:%YaLim_r_1%:%YaLim_r_2%

;Write the data to the HexaPod_Geometry.txt file
    
    FileDelete, HexaPod_Geometry.txt
    
    FileAppend, BFF 6DOF Motion Driver - Hexapod Geometry and Motion Limits`n`n, HexaPod_Geometry.txt
    FileAppend, PCR upper: %Rad_u% mm`n, HexaPod_Geometry.txt
    FileAppend, PCR lower: %Rad_b% mm`n, HexaPod_Geometry.txt
    FileAppend, Height at mid-stroke: %H_mid% mm`n, HexaPod_Geometry.txt
    FileAppend, Subtended angle at actuator bottom attachments: %Ang_Sub_Deg% deg`n, HexaPod_Geometry.txt
    FileAppend, Actuator linear stroke length: %Act_Stroke% mm`n, HexaPod_Geometry.txt
    FileAppend, Crank type actuator: %Cranked% Crank Radius %Crank_Radius% mm Calculated crank rotation: %Crank_Rot_deg% deg`n, HexaPod_Geometry.txt
    FileAppend, Height of Pitch/Roll center above upper pitch circle: %Rot_Height% mm `n`n, HexaPod_Geometry.txt
    FileAppend, Calculated Movement Ranges`n`n, HexaPod_Geometry.txt
    FileAppend, Pitch`n, HexaPod_Geometry.txt
    FileAppend, Limits: %FaLim_r_1% %FaLim_r_2% deg 1/2 Range: %FAband% deg Mid: %FAmid% deg`n, HexaPod_Geometry.txt
    FileAppend, Roll`n, HexaPod_Geometry.txt
    FileAppend, Limits: %LaLim_r_1% %LaLim_r_2% deg 1/2 Range: %LAband% deg Mid: %LAmid% deg`n, HexaPod_Geometry.txt
    FileAppend, Yaw`n, HexaPod_Geometry.txt
    FileAppend, Limits: %YaLim_r_1% %YaLim_r_2% deg 1/2 Range: %YAband% deg Mid: %YAmid% deg`n, HexaPod_Geometry.txt
    FileAppend, Surge`n, HexaPod_Geometry.txt
    FileAppend, Limits: %SUaLim_r_1% %SUaLim_r_2% mm 1/2 Range: %SUAband% mm Mid: %SUAmid% mm`n, HexaPod_Geometry.txt
    FileAppend, Sway`n, HexaPod_Geometry.txt
    FileAppend, Limits: %SWaLim_r_1% %SWaLim_r_2% mm 1/2 Range: %SWAband% mm Mid: %SWAmid% mm`n, HexaPod_Geometry.txt
    FileAppend, Heave`n, HexaPod_Geometry.txt
    FileAppend, Limits: %VaLim_r_1% %VaLim_r_2% mm 1/2 Range: %VAband% mm Mid: %VAmid% mm`n, HexaPod_Geometry.txt
    
    FileAppend, `nRange Internal Working Values:`n`n, HexaPod_Geometry.txt
    FileAppend, Actuator Range: (in position feedback units): %Act_Range%`n, HexaPod_Geometry.txt
    FileAppend, Mid Positions: %Act1_mid% %Act2_mid% %Act3_mid% %Act4_mid% %Act5_mid% %Act6_mid%`n, HexaPod_Geometry.txt
    FileAppend, Start Positions: %PitchStart% %RollStart% %HeaveStart% %SurgeStart% %SwayStart% %YawStart%`n, HexaPod_Geometry.txt
    
  }

Sleep, 250

;Run the main initialisation function init()

iret := init()
if (iret = 20)
  Goto Finish
else if (iret != 0)
	{
    MsgBox, Error on Initialisation %iret% ..... closing driver
    Goto Finish
  }

;
;==========================================================================
;Initialise the calc variables
;==========================================================================
;

GuiControl,, MyText, Initialising calculation variables.............
if Regtxt_active
  GuiControl,13:,RegTxt2, Initialising calculation variables....
Sleep, 250

; And initiate some numeric storage variables for the running calcs

T_Prev := 1.0
aaT_Now1 := 1
aaT_Now2 := 1

restn := DllCall("QueryPerformanceFrequency", "Int64*", aaCal)

DeltaT1 := 0.0
DeltaT2 := 0.0

restn := DllCall("QueryPerformanceCounter", "Int64*", aaT_Now2)
T_Now := aaT_Now2 / aaCal
T_Prev := T_Now
T_Timer := T_Now

icount := 0
aicount2 := 0

icnt_on := 0
icnt_rec := 0

iFb := 1.0
iLb := 1.0
iVb := 1.0
iSub := 1.0
iSwb := 1.0
iYb := 1.0

Roll_Scale := 1.0
i_rs := 0

v_Mode := "NONE"

VarSetCapacity(TCP_Buffer, 2000, 0)

yaw_rate_prev := 0.0

if (Mode = "GAL")
{
  mp1_max := FALim2
  mp1_min := FALim1
  mp2_max := LALim2
  mp2_min := LALim1
  mp3_max := VALim2
  mp3_min := VALim1
  mp4_max := SUALim2
  mp4_min := SUALim1
  mp5_max := SWALim2
  mp5_min := SWALim1
  mp6_max := YALim2
  mp6_min := YALim1
}
else
{
  mp1_max := 255
  mp1_min := 0
  mp2_max := 255
  mp2_min := 0
  mp3_max := 255
  mp3_min := 0
  mp4_max := 255
  mp4_min := 0
  mp5_max := 255
  mp5_min := 0
  mp6_max := 255
  mp6_min := 0 
  
}

Engine_RPM := 0

Use_Turb = 0      ;X-Plane version - start with recorded turb heave effects off
Orig_Turb := Use_Turb

GuiControl,, MyProgress, 80
GuiControl,, MyText, Variables initialised............
if Regtxt_active
  GuiControl,13:,RegTxt2, Variables initialised....
Sleep, 250

;Set the progress bar ranges

FALim1b := FALim1 * 10      ;b subscript indicates values used for output bar ranges only
FALim2b := FALim2 * 10
LALim1b := LALim1 * 10
LALim2b := LALim2 * 10
VALim1b := VALim1 * 10
VALim2b := VALim2 * 10

SuALim1b := SuALim1 * 10      ;b subscript indicates values used for output bar ranges only
SuALim2b := SuALim2 * 10
SwALim1b := SwALim1 * 10
SwALim2b := SwALim2 * 10
YALim1b := YALim1 * 10
YALim2b := YALim2 * 10

if (Rig_Type = 4 OR Rig_Type = 5)
	{
	Range := FALim1b "-" FALim2b
	GuiControl, +Range%Range%, PitchBar
	Range := LALim1b "-" LALim2b	
	GuiControl, +Range%Range%, RollBar
	Range := VALim1b "-" VALim2b	
	GuiControl, +Range%Range%, HeaveBar
	
	Range := SuALim1b "-" SuALim2b
	GuiControl, +Range%Range%, SurgeBar
	Range := SwALim1b "-" SwALim2b	
	GuiControl, +Range%Range%, SwayBar
	Range := YALim1b "-" YALim2b	
	GuiControl, +Range%Range%, YawBar
	}
else
	{
	Range := FALim1b "-" FALim2b
	GuiControl, +Range%Range%, PitchBar

	Range := LALim1b "-" LALim2b
	GuiControl, +Range%Range%, RollBar

  if (VALim1 != VALim2)
    {
	     Range := VALim1b "-" VALim2b
	     GuiControl, +Range%Range%, HeaveBar
    }
  else
    {
      Range = 1-255
      GuiControl, +Range%Range%, HeaveBar
    }
	}

;Adjust the Manual Slider ranges if mode is GAL

if (Mode = "GAL")
  {
  Range := FALim1 "-" FALim2
  GuiControl, 3: +Range%Range%, man_pos1
  Range := LALim1 "-" LALim2	
  GuiControl, 3: +Range%Range%, man_pos2
  Range := VALim1 "-" VALim2	
  GuiControl, 3: +Range%Range%, man_pos3
  Range := SUALim1 "-" SUALim2
  GuiControl, 3: +Range%Range%, man_pos4
  Range := SWALim1 "-" SWALim2	
  GuiControl, 3: +Range%Range%, man_pos5
  Range := YALim1 "-" YALim2	
  GuiControl, 3: +Range%Range%, man_pos6
  }

;
; Final adjustment to settings - if Mode is BIN then the Booleans are not needed and the Use_Bool parameter will reset to 0

;	if (Mode != "HEX2" AND Mode != "MEM")
;		Use_Bool := 0
		
;Set to Hold mode
  
  if (Drive_on_Start = 1)
    {
      iDrive := 1
      Crashed_Flag := 0
      Flight_Int := 0
      DllCall("QueryPerformanceCounter", "Int64*", T_Now_D)
      T_Drive := T_Now_D * 1.0 / aaCal
    }
  else
    iDrive := 0
  
;Set the actuator drive directions, used to reverse the individual actuator drive direction if needed by irreversible encoder feedback

  Act1_Sense := 1
  Act2_Sense := 1
  Act3_Sense := 1
  
  Act4_Sense := 1
  Act5_Sense := 1
  Act6_Sense := 1
    
;If iscope1=1 then initiate the scope

  Scope_Mode1 := Scope_Mode
  Scope_Mode2 := Scope_Mode

  if (iscope1 = 1)
    {
    Title := "BFF Motion Driver Cue by DOF - Pitch (Green), Roll (Pink), Heave (Yellow)"
    rc_scope := Scope(Title, 0, 0, 0, hModule_Scope, hScope1, Mode, Scope_Init1)
    if rc_scope
      Goto Finish
    }
  if (iscope2 = 1)
    {
    Title := "BFF Motion Driver Cue by DOF - Surge (Green), Sway (Pink), Yaw (Yellow)"
    rc_scope := Scope(Title, 0, 0, 0, hModule_Scope, hScope2, Mode, Scope_Init2)
    if rc_scope
      Goto Finish
    }
  if (iscope3 = 1)
    {
    Title := "BFF Motion Driver Cue by DOF - Surge (Green), Sway (Pink), Yaw (Yellow)"
    rc_scope := Scope(Title, 0, 0, 0, hModule_Scope, hScope3, Mode, Scope_Init3)
    if rc_scope
      Goto Finish
    }
  
;Reset demo elapsed flag
    
  demo_elapsed := 0
    
; Set data_read flag

  data_read := 0  
  FVel_prev := 0.0
  DF_max := 0.0
  
;Set the crashed flag

  Crashed_Flag := 0  
  Flight_Int := 0
  
;Ensure TCP forwarding is OFF

  IP_F_target := "0.0.0.0"
  


  PSX_TickCount_prev := 0.0
  T_elapsed_Int := 0.0
  T_elapsed := 0.0
  T_elapsed_prev2 := 0.0
  Heading_Rad_prev := 0.0
  
  Pos_X_prev := 0.0
  Pos_Y_prev := 0.0
  
  Pos_X_chk_prev := 0.0
  Pos_Y_chk_prev := 0.0
  
  DllCall("QueryPerformanceCounter", "Int64*", T_Stamp_prev)
  T_Stamp_prev /= (1.0 * aaCal)
  ;MsgBox, T_Stamp_prev: %T_Stamp_prev%
  
  VelN_prev := 0.0
  VelE_prev := 0.0
  VelV_prev := 0.0
  
  Alt_MSL_prev := 0.0
  
  T_Interrupt := 0.0
  Interrupt_Holding := 0
  Interrupt_Period := 5.0 ;secs
  
  iscope1 := 0
  iscope2 := 0
  iscope3 := 0
  
  Pause_ind := 0  ;start on unpause
  i_paused := 0
  i_FVel := 0
  
  Delta_T_PSX := 0.02
  Delta_T_PSX_prev := 0.02
  
  Lat_Rad_prev := 0.0
  Long_Rad_prev := 0.0
  
  LatDeg_prev := 0
  LongDeg_prev := 0
  
  Just_Started := 1
                               
  FVel_check := 0.0
  
  P_State_prev := "U"
  Pause_toggle := 0
  
  DVN_prev := 0.0
  DVE_prev := 0.0
  DVV_prev := 0.0
  
  Flight_Int_mess := 0
  T_elapsed_mess := 0
  Pause_mess := 0
  Interrupt_Holding_mess := 0
  
  iloop := 0
  read_loop := 0
  
  buf_len := 0
  working_len := 0
  
  VarSetCapacity(Working_Buffer,100000,0)
  VarSetCapacity(Packet_Buffer,100,0) 

;======================================================================
;
;Finally - the start of the main processing loop...........................
;
;======================================================================

GuiControl,, MyProgress, 100
GuiControl,, MyText, Starting main data processing................
if Regtxt_active
  GuiControl,13:,RegTxt2, Starting main data processing....
Sleep, 250

;Set the process priority to the state from the .bff config file
;MsgBox, %Priority%
Process Priority,, %Priority%

;Purge the TCP buffer


if (Socket_Opened = 1)
{
  DataSizeAvail := CheckBuffer(X_Socket)
  VarSetCapacity(TCP_Buffer,10000,0)  ;clear the buffer
}
  iret := Read_XData(X_Socket, DataSizeAvail, TCP_Buffer)


MainLoop:


;Fade out the registration splash window

iloop += 1


if Regtxt_active
{
  Trans_val := 255 - (3 * iloop)
  if (Trans_val <= 0)
    {
      Gui, 13:Destroy
      Regtxt_active := 0
    }
  else
    WinSet, Transparent, %Trans_val%, BFF_Registration
}

;Check the PSX window status for pause detect - disabled as pausing does not cause too much disruption to cues

/*
SetTitleMatchMode, 2
ifWinActive ,Precision Simulator,,Instructor
  PSX_status := 1
else
  PSX_status := 0
        
;Check the Pause key state
  GetKeyState, P_state, P
  
;Has pause toggle happened?
  if (PSX_status = 1 AND P_State = "D" AND P_State_prev = "U")
  {
    if (Pause_ind = 0)
    {
      Pause_ind := 1
      i_FVel := 0 ;period of consistent movement following puase now required to auto-unpause
      FileAppend, `n`n%A_Now%: loop: %iloop%: P key press detected when PSX window has focus - pausing - sending to hold....`n, 6DOF.log
    }
    else if (Pause_ind = 1)
      Pause_ind := 0
  }
  
  P_State_prev := P_State
*/
  
;Check for exit state

;From Keyboard

	GetKeyState, state, %Key_Kill%	; Check if Kill hotkey is depressed to exit program
	if (state = "D" AND Key_Kill != "NONE")
	{
  	FileAppend, `n`n%A_Now%: loop: %iloop%: KILL key press detected (%Key_Kill%) - killing program....`n, 6DOF.log
    goto Finish
  }
  
;Check to see if Use Recorded Heave is to be toggled

	GetKeyState, state1, %Key_Prefix%
	if (state1 = "D")
		{
		GetKeyState, state2, B
		if (state2 = "D")
			{
			if (Use_Turb = 1)
				{
				Use_Turb := 0
				Orig_Turb := Use_Turb
				}
			else
				{
				Use_Turb := 1
				Orig_Turb := Use_Turb
				}
 		  Sleep, 100
			}

		GetKeyState, state2, %Key_Drive%	;Check if B is also depressed
		if (state2 = "D" AND Key_Drive != "NONE" AND Interrupt_Holding = 0)
			{
        iDrive := 1
        Crashed_Flag := 0
        Flight_Int := 0
        DllCall("QueryPerformanceCounter", "Int64*", T_Now_D)
        T_Drive := T_Now_D * 1.0 / aaCal
      }
			
		GetKeyState, state2, %Key_Hold%	;Check if B is also depressed
		if (state2 = "D" AND Key_Hold != "NONE")
			{
        iDrive := 0
      }
		}

;From joystick

  if Joy_But
  {

  if But_Kill
  {
	GetKeyState, state, %Joy_But%Joy%But_Kill%	; Check if Kill button is depressed to exit program
	if (state = "D")
		goto Finish
	}

  if But_Drive
  {
	GetKeyState, state2, %Joy_But%Joy%But_Drive%
		if (state2 = "D" AND Interrupt_Holding = 0)
			{
        iDrive := 1
        Crashed_Flag := 0
        Flight_Int := 0
        DllCall("QueryPerformanceCounter", "Int64*", T_Now_D)
        T_Drive := T_Now_D * 1.0 / aaCal
      }
	}	
  if But_Hold
  {	
		GetKeyState, state2, %Joy_But%Joy%But_Hold%	;Check if B is also depressed
		if (state2 = "D")
			{
        iDrive := 0
      }
	}

  }

;if using joystick input check that the joystick exists

if (Use_Joy != 0)      
  {
    GetKeyState, JoyName, %Use_Joy%JoyName
    ;MsgBox, %Use_Joy% : %JoyName%
      if JoyName =
      {
        GuiControl,, MyText, Joystick number %Use_Joy% not detected - Closing driver.
		    MsgBox, Joystick number %Use_Joy% not detected - Closing driver.
		    Goto Finish
      }
  }

;
;Data read from the flight sim - 1st for local sim process
;

if (Use_Joy = 0)
{
read_next2:

  read_loop += 1

  ;Check if TCP data is available
  
  DataSizeAvail := CheckBuffer(X_Socket)
  
  ;if data is available read it into the clean buffer
  
  if (DataSizeAvail > 0 AND working_len < 9900) ;if there is room in the receive buffer
  {
    VarSetCapacity(TCP_Buffer,100000,0)  ;clear the buffer
    iret := Read_XData(X_Socket, DataSizeAvail, TCP_Buffer)   
  
    ;Add the new data into the working buffer
    
    DllCall("RtlMoveMemory", "UInt", &Working_Buffer+working_len, "UInt", &TCP_Buffer, "Uint", DataSizeAvail)
  
    ;Update the working buffer length
    
    working_len += DataSizeAvail
  }
  
  ;If there is not enough data in the working buffer then wait until there is some...  packet size is about 60 bytes
  
  if (working_len < 50)
  {
    GuiControl,, TCP_Text, Waiting... %i_wait%
      
    i_wait += 1
    if (i_wait > 10000)               ;interrupted data
    {
      if (Park_on_Int = 0)        ;loop with old data but don't set interrupted flag
        Goto PostData   
      else if (i_wait > 10100)     ;too long a delay - set interrupted flag then continue - !!!may resume with big step in data!!!
      {
        Flight_Int := 1
        Goto PostData            
      }
    }
    Goto read_next2
  }
  else
    i_wait := 0
  
  
  ;Now if there is data in the working buffer pull the first packet
  
  ;Get the F and G character positions - these indicate the start of a data packet
  Position_F := InStr(Working_Buffer, "F", 1)
  Position_G := InStr(Working_Buffer, "G", 1)
  
  ;Decide what comes first
  if (Position_F = 0 AND Position_G = 0)  ;no start data in buffer, read more data
  {
    Goto read_next2
  }
  else if (Position_F = 0)  ;then it must be G data
    Start_Pos := Position_G
  else if (Position_G = 0)  ;then it must be F data
    Start_Pos := Position_F
  else  ;then both must be present
  {
    if (Position_G < Position_F)  ;G data is first
      Start_Pos := Position_G
    else  ;F data is first
      Start_Pos := Position_F
  }
  
  Start_Pos -= 1  ;correct to normal "offset" positioning
    
  ;We must have start position for data packet - so find the end of the data packet
  
  Position_nl := InStr(Working_Buffer, "`n") ;this is the end of packet byte
  Position_lf := InStr(Working_Buffer, "`r")
  
  if (Position_nl = 0 AND Position_lf = 0)  ;then there is no end of packet indicator - go get some more data
    Goto read_next2
  
  Position_nl -= 1  ;correct to normal "offset" positioning
  Position_lf -= 1
  
  ;If the `n is BEFORE the Start pos then we have a part packet at the buffer start
  ;so clear it and check again
  
  if (Position_nl < Start_Pos)
  {
    Count := Position_nl + 1  ;ie number of bytes up to and including `n
    DllCall("RtlMoveMemory", "UInt", &Working_Buffer, "UInt", &Working_Buffer+Count, "Uint", working_len-Count)
    working_len -= Count  ;update the working length of the buffer
    Goto read_next2
  }
  else  ;otherwise pull the 1st packet into Packet_Buffer and left trim the working buffer
  {
    working_len_out := working_len
    Count := Position_nl - Start_Pos + 1
    VarSetCapacity(Packet_Buffer,100,0)
    DllCall("RtlMoveMemory", "UInt", &Packet_Buffer, "UInt", &Working_Buffer+Start_Pos, "Uint", Count)
    if (working_len - Count >= 0)  ;if there is anything left over then left trim the working buffer
    {
      DllCall("RtlMoveMemory", "UInt", &Working_Buffer, "UInt", &Working_Buffer+Count, "Uint", working_len-Count)
      working_len -= Count  ;update the working length of the buffer
    }
    ;Get the local timestamp for the data read
    DllCall("QueryPerformanceCounter", "Int64*", T_Stamp)
    T_Stamp /= (1.0 * aaCal)
  }
  
  ;proceed to process the extracted packet
  
;=======================================================

;Set the nominal version number

	Xvers := 10     
}

;And for joystick input

else if (Use_Joy != 0)     Read the joystick axis positions
{
  GetKeyState, joyx_val, %Use_Joy%JoyX    ;in range 0-50-100
  GetKeyState, joyy_val, %Use_Joy%JoyY
  GetKeyState, joyz_val, %Use_Joy%JoyZ
  
  joyx_val -= 50.0    ;now in range -50 to +50
  joyy_val -= 50.0
  joyz_val -= 50.0
  
  Xvers := 01

}

; Get the data - fitst for PSX data input

  if (Xvers = 10)      ;now for the PSX TCP data packet
  {
    ;Parse the text string (parse by colon, new line and line feed, remove leading and trailing blanks)
    
    Packet := StrGet(&Packet_Buffer, 100, 0)
    Loop, parse, Packet, `;`n`r, %A_Space%%A_Tab%
    {
      Param_%A_Index% := A_LoopField
    }
    
    ;Check the packet
    
    if (Param_1 != "F" and Param_1 != "G")  ;invalid packet
    {
      Bad_Packet := 1
      Goto MainLoop
    }
    else
      Bad_Packet := 0
      
    ;Calculate the PSX  and local data receive elapsed time
      
    PSX_TickCount := Param_8 * 1.0
    if (PSX_TickCount = PSX_TickCount_prev) ;repeat TCP packet with same timestamp - discard
    {
      Bad_Packet := 1
      PSX_TickCount_prev := PSX_TickCount
      Goto MainLoop
    }
    else if (PSX_TickCount < PSX_TickCount_prev) ;roll over has occurred
    {
      T_elapsed_Int += 1.0  ;Add 1 sec onto T_Elapsed  
    }
    T_elapsed := T_elapsed_Int + (PSX_TickCount / 1000.0)
    
    Delta_T_PSX_prev := Delta_T_PSX ;record previous DT before new one is calculated
    Delta_T_PSX := T_elapsed - T_elapsed_prev2
    
    Delta_T_PSX_prev_ave := BFF_Ave3(1, Delta_T_PSX_prev) ;calc an average
    
    ;Don't allow big time steps to be sent through - eg if PSX is paused
    if (Delta_T_PSX > 0.05)
      Delta_T_PSX := 0.05
    
    PSX_TickCount_prev := PSX_TickCount
    T_elapsed_prev2 := T_elapsed
    
    ;FileAppend, %iloop% %Param_8% %T_elapsed% %Delta_T_PSX_prev% %Delta_T_PSX%`n, Data2.txt
    
    ;Calculate the local elapsed time
    
    Delta_T_Local := T_Stamp - T_Stamp_prev
    T_Stamp_prev := T_Stamp
    ;if (Delta_T_Local > 0.05)
    ;  Goto MainLoop
    
    ;On ground status
    if (Param_1 = "G")
      OnGrnd := 1
    else
      OnGrnd := 0
      
    ;Get lat and long angles
    
    LatDeg := Param_6   ;north +ve
    LongDeg := Param_7  ;east +ve
    Lat_Rad := LatDeg / 360.0 * 2.0 * pi
    Long_Rad := LongDeg / 360.0 * 2.0 * pi
    
    ;Prelim position change calcs to determine unpaused state
    
    R := 6371.0 * 1000.0 ;earth approx radius in m
    Pos_X_chk := R * Long_Rad * cos(Lat_Rad)   ;r λ cos(φ0) - simple equirectangular projection for this check
    Pos_Y_chk := R * Lat_Rad
    
    Delta_PosE_chk := Pos_X_chk - Pos_X_chk_prev
    Delta_PosN_chk := Pos_Y_chk - Pos_Y_chk_prev
    Delta_Pos_chk := Sqrt(Delta_PosE_chk**2 + Delta_PosN_chk**2)
    
    Pos_X_chk_prev := Pos_X_chk
    Pos_Y_chk_prev := Pos_Y_chk
    
    if (Delta_Pos_chk != 0.0)  ;if non-zero Delta P start the counter, if this is zero or low then there has been no recent movement
      i_FVel += 1
    else
      i_FVel := 0
      
    ;Reset to unpaused if consistent movement has been detected

    if (i_FVel > 200)
      Pause_ind := 0
    
    ;Deal with paused conditions
    
    if (iloop > 100) ;allow data to populate - later on no output is allowed until more than 100 loops
    {
      if (Pause_ind = 1)
      {
        if (Disp_Data = 1)
          GuiControl,14:,Data_Text , Reading from Port %PortS% on %IPAddress%`n DataSizeAvail: %DataSizeAvail%`n`n T_elapsed: %T_elapsed%`n Delta_T_PSX: %Delta_T_PSX%`n`n HeadingDeg: %HeadingDeg%`n RollDeg: %RollDeg%`n PitchDeg: %PitchDeg%`n`n FVel: %FVel%`n`n OnGrnd: %OnGrnd%`n`n Facc: %Facc%`n Lacc: %Lacc%`n Vacc2: %Vacc2% 
        Goto PostData  ;continue to output but with previous vel & accel data
      }
      else  ;so assume active
      {
        if (Interrupt_Holding = 1)  ;deal with existing interrupt
        {
          if (T_Stamp - T_Interrupt > Interrupt_Period)
          {
            GuiControl, Enable, _Drive
            Interrupt_Holding := 0
          }
        }
        else if (Delta_Pos_chk > 250.0)  ;step change bigger than 250 meters - major change in situation
        {
          T_Interrupt := T_Stamp
          Interrupt_Holding := 1
          GuiControl, Disable, _Drive ;disable the Drive button for 5 seconds
          FileAppend, `n`n%A_Now%: loop: %iloop%: Excessive Delta Pos detected (%Delta_Pos_chk% meters) - sending to hold....`n, 6DOF.log
        }
      }
    }
    
    LatDeg_prev := LatDeg
    LongDeg_prev := LongDeg
    
    ;Altitude above MSL
    
    Alt_MSL := Param_2 / 100.0 * 12 * 25.4 / 1000.0 ;covert from ft*100 to m
    
    ;Vertical Speed - Global
    
    Delta_PosV := Alt_MSL - Alt_MSL_prev
    Alt_MSL_prev := Alt_MSL
    
    if (Delta_PosV > 2.0)  ;don't let startup or other big position steps into the low-pass filter
      Delta_PosV := 0.0
    
    ;Velocity
    VelV_unsmoothed := Delta_PosV / Delta_T_PSX ; / 0.515  ;in m/s  +ve upwards
    VelV := LP_Filter(0.1, VelV_unsmoothed, Delta_T_PSX, 1)
    
    ;True Heading, Pitch and Roll
    
    HeadingDeg := Param_3 / 100.0   ;if abs(lat)>89: grid HDG, else longitudinal HDG, , 0 Deg = North, 90 Deg = East?
    
    ; Convert Heading, 0 Deg = North, 90 Deg = East - change to 0 Deg =  East & +90 Deg = North

	  HeadingDeg := HeadingDeg * -1.0 + 90
    Heading_Rad := HeadingDeg / 360.0 * 2 * pi
    
    PitchDeg := Param_4 / 100.0 ;+ve nose up, keep as is
    Pitch_Rad := PitchDeg / 360.0 * 2 * pi
    
    RollDeg := Param_5 / -100.0  ;comes in +ve bank left, change to +ve bank right
    Roll_Rad := RollDeg / 360.0 * 2 * pi
    
    ;Yaw Velocity - use DT(i) for this
    
    Heading_Diff := Heading_Rad - Heading_Rad_prev
    
    ;Heading is in range +90 to -270, so handle the crossover
    
    if (Heading_Rad > 0.0 AND Heading_Rad_prev < 0.0)
      Heading_Diff := (2 * pi) - Heading_Diff
    else if (Heading_Rad < 0.0 AND Heading_Rad_prev > 0.0)
      Heading_Diff := (2 * pi) + Heading_Diff 
    
    if (Abs(Heading_Diff) > 0.1)  ;don't let startup or other big position steps into the low-pass filter
      Heading_Diff := 0.0
    
    ;Yaw velocity
    
    VelR_unsmoothed := Heading_Diff / Delta_T_PSX
    ;Filter it
    VelR := LP_Filter(0.1, VelR_unsmoothed, Delta_T_PSX, 2)
    
    Heading_Rad_prev := Heading_Rad
    
    ;Yaw "acceleration" for the cue development
    
    Yaw_acc := VelR       ;use yaw velocity instead of Yaw acceleration for cue
    Yaw_acc_deg := VelR / 2 / pi * 360.0
    
    ;Global position changes
    
    /*
    Haversine
    formula: 	a = sin²(Δφ/2) + cos φ1 ⋅ cos φ2 ⋅ sin²(Δλ/2)
    c = 2 ⋅ atan2( √a, √(1−a) )
    d = R ⋅ c
    where 	φ is latitude, λ is longitude, R is earth’s radius (mean radius = 6,371km);
    note that angles need to be in radians to pass to trig functions!
    JavaScript: 	

    var R = 6371000; // metres
    var φ1 = lat1.toRadians();
    var φ2 = lat2.toRadians();
    var Δφ = (lat2-lat1).toRadians();
    var Δλ = (lon2-lon1).toRadians();

    var a = Math.sin(Δφ/2) * Math.sin(Δφ/2) +
        Math.cos(φ1) * Math.cos(φ2) *
        Math.sin(Δλ/2) * Math.sin(Δλ/2);
    var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));

    var d = R * c;
    */
    
    delta_lat := Lat_Rad - Lat_Rad_prev
    
    if (delta_lat = 0.0)
      DLa_sign := 1
    else 
      DLa_sign := abs(delta_lat) / delta_lat
    
    delta_long := Long_Rad - Long_Rad_prev
    
    if (delta_long = 0.0)
      DLo_sign := 1
    else 
      DLo_sign := abs(delta_long) / delta_long
    
    R := 6371.0 * 1000.0 ;earth approx radius in m
    
    ;Delta P E is from change in longitude (delta lat = 0)
    
    a_1 := 0.0
    a_2 := cos(Lat_Rad)
    a_3 := cos(Lat_Rad_prev)
    a_4 := sin(delta_long/2.0)
    a := a_1**2 + (a_2 * a_3 * a_4**2)
    c := 2 * atan4(sqrt(a), sqrt(1-a))
    Delta_PosE := R * c * DLo_sign
    
    if (delta_long = 0.0)
      Delta_PosE := 0.0
    
    ;Delta P N is from change in latitude (delta long = 0)
    
    a_1 := sin(delta_lat/2.0)
    a_2 := cos(Lat_Rad)
    a_3 := cos(Lat_Rad_prev)
    a_4 := 0.0
    a := a_1**2 + (a_2 * a_3 * a_4**2)
    c := 2 * atan4(sqrt(a), sqrt(1-a))
    Delta_PosN := R * c * DLa_sign
    
    if (delta_lat = 0.0)
      Delta_PosN := 0.0  
    
    ;FileAppend, %iloop% %a_1% %a_2% %a_3% %a_4% %a% %c% %Delta_PosN%`n, Data2.txt
    ;FileAppend, %iloop% %delta_lat% %delta_long% %Delta_T_PSX%`n, Data2.txt
    
    Lat_Rad_prev := Lat_Rad
    Long_Rad_prev := Long_Rad
        
    Delta_Pos := Sqrt(Delta_PosE**2 + Delta_PosN**2)
    
    ;Global velocities
    
    ;East component
    
    if (Delta_PosE > 20.0)  ;don't let startup or other big position steps into the low-pass filter
      Delta_PosE := 0.0
    VelE := Delta_PosE / Delta_T_PSX_prev
    
    ;North component
    
    if (Delta_PosN > 20.0)  ;don't let startup or other big position steps into the low-pass filter
      Delta_PosN := 0.0
    VelN := Delta_PosN / Delta_T_PSX_prev
        
    ;Resultant - display
    
    if (Delta_Pos > 20.0)  ;don't let startup or other big position steps into the low-pass filter
      Delta_Pos := 0.0
    FVel := Delta_Pos / Delta_T_PSX_prev  ; / 0.515  ;in m/s
    
    ;FileAppend, %iloop% %VelE% %VelN% %FVel% %Delta_T_PSX%`n, Data2.txt
    
    ;Update previous values
    
    FVel_prev := FVel
    VelV_prev := VelV
    
    ;Global Accelerations
    
    DVN := VelN - VelN_prev
    DVE := VelE - VelE_prev
    DVV := VelV - VelV_prev
    
    ;Average delta V's
    DVN_ave := BFF_Ave3(2, DVN)
    DVE_ave := BFF_Ave3(3, DVE)
    DVV_ave := BFF_Ave3(4, DVV)
    
    ;Update the prevs
    VelN_prev := VelN
    VelE_prev := VelE
    VelV_prev := VelV
    
    ;Allow a number of loops to run to make sure Delta P's and V's are set up properly at startup
    
    if (iloop < 10)
      Goto MainLoop
      
    ;Now calculate the accelerations
    
    Delta_T_Filter := Delta_T_PSX_prev
    if (Delta_T_Filter >= 0.04)  ;if big jump in DT then use average DV to calc Accel
      Delta_T_Filter := Delta_T_PSX_prev_ave
    
    Nacc_unsmoothed := DVN_ave / Delta_T_Filter
    Eacc_unsmoothed := DVE_ave / Delta_T_Filter
    Vacc_unsmoothed := DVV / Delta_T_Filter
    
    Nacc := LP_Filter(0.1, Nacc_unsmoothed, Delta_T_Filter, 3)
    Eacc := LP_Filter(0.1, Eacc_unsmoothed, Delta_T_Filter, 4)
    Vacc := LP_Filter(0.1, Vacc_unsmoothed, Delta_T_Filter, 5)
    
    
    /*
    ;For info local velocity components - to test tranform
    
    vS := Sqrt(VelN**2 + VelE**2 + VelV**2) 
	  vSi := VelN / vS
	  vSk := VelE / vS
	  vSj := VelV / vS
    
    ier := Transform(vS, vSi, vSj, vSk, Heading_Rad, Roll_Rad, Pitch_Rad, vSi3, vSj3, vSk3)

    Fv := vS * vSk3
	  Lv := vS * vSi3
	  Vv := vS * vSj3
    */
    
    ;Convert accelerations to to local
    
    ;Calc the aircraft's acceleration vector magnitude and its direction cosines

	  Vacc += 9.81		;It is convenient to add in gravitational acceleration at this point so that the resulting local acceleration components can be used
				          ;to determine "felt" force effects directly, rather than adjusting them later for the effects of aircraft pitch and roll.

	  aS := Sqrt(Nacc**2 + Eacc**2 + Vacc**2) 
	  aSi := Nacc / aS
	  aSk := Eacc / aS
	  aSj := Vacc / aS

    ; Transform the direction cosines from the global axis system into the aircraft's local axis system

	  ier := Transform(aS, aSi, aSj, aSk, Heading_Rad, Roll_Rad, Pitch_Rad, aSi3, aSj3, aSk3)

    ; We now have direction cosines for the acceleration vector in the aircraft's axis system where
    ;	z (k direction cosine) is +ve forward
    ;	x (i direction cosine) is lateral (left when looking forward is +ve)
    ;	y (j direction cosine) is +ve up .....................       so

	  Facc := aS * aSk3
	  Lacc := aS * aSi3 * -1.0  ;and invert for consistency with roll
	  Vacc2 := aS * aSj3

	  Vacc2 -= 9.81		;Remove gravitational acceleration from the vertical component to leave the additional "gForce" in the local vertical direction
				              ;These then constitue the pilot's "felt" acceleration components in the aircraft's local axis system.
                      
    if (Disp_Data = 1)
    {
      GuiControl,14:,Data_Text , Reading from Port %PortS% on %IPAddress%`n DataSizeAvail: %DataSizeAvail%`n`n T_elapsed: %T_elapsed%`n Delta_T_PSX: %Delta_T_PSX%`n`n HeadingDeg: %HeadingDeg%`n RollDeg: %RollDeg%`n PitchDeg: %PitchDeg%`n`n FVel: %FVel%`n`n OnGrnd: %OnGrnd%`n`n Facc: %Facc%`n Lacc: %Lacc%`n Vacc2: %Vacc2% 
      ;GuiControl,14:,Data_Text , Reading from Port %PortS% on %IPAddress%`n DataSizeAvail: %DataSizeAvail%`n`n T_elapsed: %T_elapsed%`n 1:%Param_1%`n 2:%Param_2%`n 3:%Param_3%`n 4:%Param_4%`n 5:%Param_5%`n 6:%Param_6%`n 7:%Param_7%`n 8:%Param_8% ;`nPacket: %Packet% 
    }
  }
  
  else if (Xvers = 01)      ;joystick input
  {
    MsgBox, Joystick inpu is NOT active in the version of the Motion Software.
    Goto Finish
    
    T_elapsed := Round(T_Now, 3)
  	FVelX := 0.0
  	
    gFV := 0.0
  	gFF := 0.0
  	gFL := 0.0
  	
  	PitchDeg := 0.0	
  	RollDeg := 0.0	
  	HeadingDeg := 0.0
    
  	OnGrnd := 0.0
  	
  	VelR := 0.0
    
    Spare1 := 0.0
    Spare2 := 0.0
  	
  	Yaw_acc := 0.0
    Yaw_acc_deg := 0.0
    
    ;if (Disp_Data = 1)
    ;{
    ;  GuiControl,14:,Data_Text , Data direct from joystick: %Use_Joy%`n`n T_elapsed: %T_elapsed% 
    ;}
    
    DllCall("Sleep", UInt, 10)
    }
  
  ;If a bad packet has been detected then 
    
  if (Bad_Packet = 1)
    Goto MainLoop

PostData:
	
  ;Insert delay if specified

	if (MD_Delay > 0)
  {
    MMRESULT := DllCall("winmm\timeBeginPeriod", "UInt", 1)
    DllCall("Sleep", UInt, MD_Delay)
    MMRESULT := DllCall("winmm\timeEndPeriod", "UInt", 1)
  }
  ;else if (MD_Delay > 0)
  ;  usleep2(0, MD_Delay)

  if (iloop < 100)  ;allow data to populate at startup
    Goto MainLoop


; Determine time step since last data set - this is needed for the washout and smoothing filters in the cue calculation
; functions below

	DllCall("QueryPerformanceCounter", "Int64*", aaT_Now2)
	T_Now_raw := aaT_Now2
	T_Now := aaT_Now2 * 1.0 / aaCal
	DeltaT := (T_Now - T_Prev)
	
	if (DeltaT = 0.0)				;If for any reason the time diff is zero we can't proceed - loop again
		goto MainLoop

	DeltaTp := DeltaT				;and if a data set is missed still use the normal time step - keeps disturbances out of the filters
	if (DeltaTp > 0.06)				;especially from game pauses, freezes etc
		DeltaTp := 0.05			;there is an argument for using a fixed time step in the calc - but I've gone with actual time step for the moment

  ;DeltaTp := Delta_T_PSX


;If joystick input substitute the current time into X-Plane elapsed time

  if (Xvers = 01)      ;joystick input
    T_elapsed := T_Now
		
;Check if running in Demo mode

If (nDemo != 0)
	{
	T_demo := T_Now - T_Timer      ;elapsed time in seconds sice Start was clicked
	if (T_demo > nDemo)
		{
		MsgBox, Demo version run time is now finished.... you must restart the driver or register it.
		Goto Finish
		}
	}

;Calc the display loop time

  jloop += 1
  if jloop = 10
  {
    DeltaTave := (aaT_Now2 - aaT_Prev_L) / aaCal / 10.0
    Hz := Round(1.0 / DeltaTave, 1)
    DeltaTout := Round(DeltaTave, 3)
    aaT_Prev_L := aaT_Now2
    jloop := 0    
  }		
	
;Check the total linear horizontal acceleration - if it is more than 5G then assume crash
;Crash_Acc now comes in from config file...
			
	Tot_acc := Sqrt(Facc **2 + Lacc ** 2 + Vacc2 ** 2)
	;if (Tot_acc > Crash_Acc)
  ;  Crashed_Flag := 1

   
;========================================================================================================
;If joystick input then replace the fwd and aft accelerations with 1g proportional to stick displacement
;

  if (Use_Joy != 0)    ;scale the joystick input to the max pitch cue input
    {
      Facc := joyy_val / 50.0 * 10.0
      Lacc := joyx_val / 50.0 * 10.0
      Vacc2 := joyz_val / 50.0 * 10.0
    }
;========================================================================================================


; Check for flight interruptions
	
	if (Flight_Int = 1)
    {
      iDrive := 0
      GuiControl,, MyText, TCP data flow stopped, sending to hold......... %Hz% Hz
      if (Flight_Int_mess = 0)
      {
        FileAppend, `n`n%A_Now%: loop: %iloop%: TCP data receive delay detected - sending to hold....`n, 6DOF.log
        Flight_Int_mess := 1
      }
      Use_Turb := Orig_Turb
		  Goto OutPut
    }
  else
    Flight_Int_mess := 0
  
  
  
 	if (Round(T_elapsed,3) = Round(T_elapsed_prev,3))
    {
      iDrive := 0
      GuiControl,, MyText, Flight interrupted, sending to hold......... %Hz% Hz
      if (T_elapsed_mess = 0)
      {
        FileAppend, `n`n%A_Now%: loop: %iloop%: T_elapsed check triggered - sending to hold....`n, 6DOF.log
        T_elapsed_mess := 1
      }
      Use_Turb := Orig_Turb
      T_elapsed_prev := T_elapsed
		  Goto OutPut                               
    }
  else
    T_elapsed_mess := 0
      
  if (Pause_ind = 1)
    {
      iDrive := 0
      GuiControl,, MyText, Flight paused - holding....
      if (Pause_mess = 0)
      {
        FileAppend, `n%A_Now%: loop: %iloop%: Flight pause triggered - sending to hold....`n, 6DOF.log
        Pause_mess := 1
      }  
      Use_Turb := Orig_Turb
		  Goto OutPut
    }
  else
    Pause_mess := 0
    
  if (Interrupt_Holding = 1)
    {
      T_Left := Round(Interrupt_Period - (T_Stamp - T_Interrupt), 1)
      
      iDrive := 0
      GuiControl,, MyText, Flight interrupted - holding....Drive available in %T_Left% secs
      if (Interrupt_Holding_mess = 0)
      {
        FileAppend, `n%A_Now%: loop: %iloop%: Excessive Delta Pos detected (%Delta_Pos_chk% meters) - sending to hold....`n, 6DOF.log
        Interrupt_Holding_mess := 1
      }
      Use_Turb := Orig_Turb
		  Goto OutPut
    }
  else
    Interrupt_Holding_mess := 0
    
  

  if (DataSizeAvail = 0)
    DataSizeAvail = 00
    
;Write status to GUI Window

	FVelout := Round(FVel,0)
	Vacc2out := Round(Tot_acc,2)
  T_elapsedout := Round(T_elapsed,1)
	Tot_acc_out := Round(Tot_acc, 1)
  OnGrnd_out := Round(OnGrnd, 0)

	GuiControl,, MyText, Data Set: %icount% DeltaT: %DeltaTout% secs Grnd Vel: %FVelout% m/s Bytes Avail: %working_len_out%
	GuiControl,, MyText2, Pulling %Vacc2out% m/s^2 On Ground: %OnGrnd_out% PSX Time: %T_elapsedout% 
	
  if (Use_Turb = 1)
		{
		if (Mode = "MEM") or (Mode = "NONE")
			GuiControl,, MyText3, Rec Heave is ON, Cranked: %Cranked%, Motion Out: %Mode%
		else
			GuiControl,, MyText3, Rec Heave is ON, Cranked: %Cranked%, Motion Out: %Mode% %Port% %Baud%
		}
	else
		{
		if (Mode = "MEM") or (Mode = "NONE")
			GuiControl,, MyText3, Rec Heave is OFF, Cranked: %Cranked%, Motion Out: %Mode%
		else
			GuiControl,, MyText3, Rec Heave is OFF, Cranked: %Cranked%, Motion Out: %Mode% %Port% %Baud%
		}

;Scale the lateral acceleration if the pitch angle is greater than 50Deg - ie fix the loop anomally in angle measurements
;scaling is exponential and largest when close to +/- 90 Deg pitch

  Pitch_Delta := 90.0 - Abs(PitchDeg)
  If (Pitch_Delta <= 40.0)
  {
    Lacc_Scale := Round((40.0 - Pitch_Delta)**4 / 20000 + 1.0, 3)
    Lacc := Lacc / Lacc_Scale
    ;SWaOut := SWaOut / Lacc_Scale
  }
;GuiControl,, MyText2, PitchDeg %PitchDeg%, Lacc_Scale %Lacc_Scale%, Lacc %Lacc%


;Calculate the Pitch DOF movement cues.............................................................................................................................................

	iret := CalcPitch(OnGrnd, Delta_T_PSX, Facc, FVel, Pitch_Rad, FaSmooth)
	if (iret = 1)
		Goto MainLoop
	
;Calculate the Heave motion cues..........................................................................................................................................................

	iret:= CalcHeave(OnGrnd, Delta_T_PSX, Vacc2, icnt_on, Use_Turb, FVel, VaSmooth)
	if (iret = 1)
		Goto MainLoop
		
;Calculate the Roll motion cues..............................................................................................................................................................

;	Rollrev := -1.0 * Roll
  Lacc *= -1.0     ;reverse the direction of the lateral accel to match the roll angle sense
	iret := CalcRoll(OnGrnd, Delta_T_PSX, Lacc, FVel, Roll_Rad, LaSmooth)
	if (iret = 1)
		Goto MainLoop
		
;Calculate the Surge DOF movement cues.............................................................................................................................................

	iret := CalcSurge(OnGrnd, Delta_T_PSX, Facc, SUaSmooth)
	if (iret = 1)
		Goto MainLoop
	
;Calculate the Yaw motion cues..........................................................................................................................................................

	iret:= CalcYaw(OnGrnd, Delta_T_PSX, Yaw_acc, YaSmooth)
	if (iret = 1)
		Goto MainLoop

;Calculate the Sway motion cues..............................................................................................................................................................

	iret := CalcSway(OnGrnd, Delta_T_PSX, Lacc, SWaSmooth)
	if (iret = 1)
		Goto MainLoop


;Protect against blank incoming data from Calc functions

	if FaSmooth =            
		FaSmooth := 0.0
	if LaSmooth =            
		LaSmooth := 0.0
	if VaSmooth =            
		VaSmooth := 0.0
		
	if SUaSmooth =            
		SUaSmooth := 0.0
	if SWaSmooth =            
		SWaSmooth := 0.0
	if YaSmooth =            
		YaSmooth := 0.0

	FaOut := FaSmooth
	LaOut := LaSmooth
	VaOut := VaSmooth
	
	SUaOut := SUaSmooth
	SWaOut := SWaSmooth
	YaOut := YaSmooth
	

;Write the limits to the capture window if it is open

  if (icapt = 1)
  {
    
  if (OnGrnd = 1)         ;reverse scaling values
    {
    cFaScale := FaScaleg
    cLaScale := LaScaleg
    cVaScale := VaScaleg
    cYaScale := YaScaleg    
    }
  else
    {
    cFaScale := FaScalea
    cLaScale := LaScalea
    cVaScale := VaScalea
    cYaScale := YaScalea    
    }
  
  if (Fout1 / cFaScale > Fwd1)
    Fwd1 := Fout1 / cFaScale
  if (Fout1 / cFaScale < Fwd2)
    Fwd2 := Fout1 / cFaScale
  
  if (Lout1 / cLaScale > L1)
    L1 := Lout1 / cLaScale
  if (Lout1 / cLaScale < L2)
    L2 := Lout1 / cLaScale
  
  if (Vout1 / cVaScale > V1)
    V1 := Vout1 / cVaScale
  if (Vout1 / cVaScale < V2)
    V2 := Vout1 / cVaScale
  
  if (PitchDeg > P1)
    P1 := PitchDeg
  if (PitchDeg < P2)
    P2 := PitchDeg
  
  if (RollDeg > B1a)
    B1a := RollDeg
  if (RollDeg < B2a)
    B2a := RollDeg
    
  if (Yout1 / cYaScale > Y1)
    Y1 := Yout1 / cYaScale
  if (Yout1 / cYaScale < Y2)
    Y2 := Yout1 / cYaScale
  
  Fwd1 := Round(Fwd1, 1)
  Fwd2 := Round(Fwd2, 1)
  L1 := Round(L1, 1)
  L2 := Round(L2, 1)
  V1 := Round(V1, 1)
  V2 := Round(V2, 1)
  P1 := Round(P1, 1)
  P2 := Round(P2, 1)
  B1a := Round(B1a, 1)
  B2a := Round(B2a, 1)
  Y1 := Round(Y1, 1)
  Y2 := Round(Y2, 1)
  
  GuiControl,2:,Fwd1 ,%Fwd1%
  GuiControl,2:,Fwd2 ,%Fwd2%
  GuiControl,2:,L1 ,%L1%
  GuiControl,2:,L2 ,%L2%
  GuiControl,2:,V1 ,%V1%
  GuiControl,2:,V2 ,%V2%
  GuiControl,2:,P1 ,%P1%
  GuiControl,2:,P2 ,%P2%
  GuiControl,2:,B1 ,%B1a%
  GuiControl,2:,B2 ,%B2a%
  GuiControl,2:,Y1 ,%Y1%
  GuiControl,2:,Y2 ,%Y2%
  }
	
	
 
	

; Update values for next loop

  T_this := T_Now
  T_last := T_Prev
   
	T_Prev := T_Now
	

;=====================================================================
;Calculate the working cues within the movement ranges of the platform
;These are in real displacement/rotation units - mm and rads
;=====================================================================

;Pitch

	if (Pitch_Rev = 1)						;reverse the direction if requested in settings
		FaOut *= -1.0

	iFaSmooth := ((FaOut / FAmax * FAband) + FAmid)	* 1.0	;calc integer value for Pitch cue using the mid position, band and max cue value allowed
	
	if (iFaSmooth < FAlim_r_1)					;enforce the limits
		 iFaSmooth := FAlim_r_1
	else if (iFaSmooth > FAlim_r_2)
		 iFaSmooth := FAlim_r_2


;Roll
	
	if (Roll_Rev = 1)						;reverse the direction if requested in settings
		LaOut *= -1.0

	iLASmooth := ((LaOut / LAmax * LAband) + LAmid) * 1.0
	
	if (iLASmooth < LAlim_r_1)
		 iLASmooth := LAlim_r_1
	else if (iLASmooth > LAlim_r_2)
		 iLASmooth := LAlim_r_2


;Heave
    
  if (Heave_Rev = 1)						;reverse the direction if requested in settings
  	VaOut *= -1.0

  iVASmooth := ((VaOut / VAmax * VAband) + VAmid) * 1.0

  if (iVASmooth < VAlim_r_1)
  		iVASmooth := VAlim_r_1
  else if (iVASmooth > VAlim_r_2)
  		iVASmooth := VAlim_r_2
  		
  
;Surge

	if (Surge_Rev = 1)						;reverse the direction if requested in settings
		SUaOut *= -1.0

	iSUaSmooth := ((SUaOut / SUAmax * SUAband) + SUAmid)	* 1.0	;calc integer value for Surge cue using the mid position, band and max cue value allowed
	
	if (iSUaSmooth < SUAlim_r_1)					;enforce the limits
		 iSUaSmooth := SUAlim_r_1
	else if (iSUaSmooth > SUAlim_r_2)
		 iSUaSmooth := SUAlim_r_2


;Sway
	
	if (Sway_Rev = 1)						;reverse the direction if requested in settings
		SWaOut *= -1.0

	iSWASmooth := ((SWaOut / SWAmax * SWAband) + SWAmid) * 1.0
	
	if (iSWASmooth < SWAlim_r_1)
		 iSWASmooth := SWAlim_r_1
	else if (iSWASmooth > SWAlim_r_2)
		 iSWASmooth := SWAlim_r_2

;Yaw
    
  if (Yaw_Rev = 1)						;reverse the direction if requested in settings
  	YaOut *= -1.0

  iYASmooth := ((YaOut / YAmax * YAband) + YAmid) * 1.0

  if (iYASmooth < YAlim_r_1)
  		iYASmooth := YAlim_r_1
  else if (iYASmooth > YAlim_r_2)
  		iYASmooth := YAlim_r_2
  		
;
; iFaSmooth, iLaSmooth etc are now the raw cues in the platform real displacement units,
; they need to be converted into real displacements of the actuators
;	 

;Set the scope DOF outputs

  iFaSmooths := iFaSmooth
  iLaSmooths := iLaSmooth
  iVaSmooths := iVaSmooth
  
  iSUaSmooths := iSUaSmooth
  iSWaSmooths := iSWaSmooth
  iYaSmooths := iYaSmooth
  
  Faccs := Facc
  Vacc2s := Vacc2
  Laccs := Lacc
  Yaw_acc2 := Yaw_acc
  
;================================
;Do the data tracing if requested

  Trace(itrace)
  
;================================


;Manual Override if by DOF

  if (i_manual = 1 AND ACT_DOF = 1)
    {
      GuiControlGet, man_pos1, 3:
      GuiControlGet, man_pos2, 3:
      GuiControlGet, man_pos3, 3:
      GuiControlGet, man_pos4, 3:
      GuiControlGet, man_pos5, 3:
      GuiControlGet, man_pos6, 3:
      
      if (i_Together = 1)   ;channels 2 & 3 follow channel 1 movements
        {
          delta_man_pos1 := man_pos1 - man_pos1_prev
            
          man_pos2 += delta_man_pos1
          man_pos3 += delta_man_pos1
          man_pos4 += delta_man_pos1
          man_pos5 += delta_man_pos1
          man_pos6 += delta_man_pos1
          
          if (man_pos1 > mp1_max)
            man_pos1 := mp1_max
          else if (man_pos1 < mp1_min)
            man_pos1 := mp1_min
            
          if (man_pos2 > mp2_max)
            man_pos2 := mp2_max
          else if (man_pos2 < mp2_min)
            man_pos2 := mp2_min
            
          if (man_pos3 > mp3_max)
            man_pos3 := mp3_max
          else if (man_pos3 < mp3_min)
            man_pos3 := mp3_min
            
          if (man_pos4 > mp4_max)
            man_pos4 := mp4_max
          else if (man_pos4 < mp4_min)
            man_pos4 := mp4_min
            
          if (man_pos5 > mp5_max)
            man_pos5 := mp5_max
          else if (man_pos5 < mp5_min)
            man_pos5 := mp5_min
            
          if (man_pos6 > mp6_max)
            man_pos6 := mp6_max
          else if (man_pos6 < mp6_min)
            man_pos6 := mp6_min
            
          GuiControl, 3:, man_pos2, %man_pos2%
          GuiControl, 3:, man_pos3, %man_pos3%
          GuiControl, 3:, man_pos4, %man_pos4%
          GuiControl, 3:, man_pos5, %man_pos5%
          GuiControl, 3:, man_pos6, %man_pos6%
        }
      
      iFaSmooth := man_pos1 / 10      ;Progress bar range is scaled for angle unit DOF's
      iLaSmooth := man_pos2 / 10
      iVaSmooth := man_pos3
      iSUaSmooth := man_pos4
      iSWaSmooth := man_pos5
      iYaSmooth := man_pos6 / 10
      
      man_pos1_prev := man_pos1
      man_pos2_prev := man_pos2
      man_pos3_prev := man_pos3
      man_pos4_prev := man_pos4
      man_pos5_prev := man_pos5
      man_pos6_prev := man_pos6
      
      ;Set the last positions
      iFaSmooth_last := iFaSmooth2
      iLaSmooth_last := iLaSmooth2
      iVaSmooth_last := iVaSmooth2
      iSUaSmooth_last := iSUaSmooth2
      iSWaSmooth_last := iSWaSmooth2
      iYaSmooth_last := iYaSmooth2
    }

    
;
; Now check the platform type and do the necessary mixing of the outputs to drive coupled DOF's
;
;3 coupled actuators

	if (Rig_Type = 4 OR Rig_Type = 5)		;hexapod - output by actuator
		{

    ;Apply the proportions of available range to use
    
    if (Pitch_prop_disable = 1)
      iFaSmooth := 0.0
    else
      iFaSmooth *= Pitch_prop / 100.0
    
    if (Roll_prop_disable = 1)
      iLaSmooth := 0.0
    else
      iLaSmooth *= Roll_prop / 100.0
      
    if (Heave_prop_disable = 1)
      iVaSmooth := 0.0
    else
      iVaSmooth *= Heave_prop / 100.0
      
    if (Surge_prop_disable = 1)
      iSUaSmooth := 0.0
    else
      iSUaSmooth *= Surge_prop / 100.0
    
    if (Sway_prop_disable = 1)
      iSWaSmooth := 0.0
    else
      iSWaSmooth *= Sway_prop / 100.0
    
    if (Yaw_prop_disable = 1)
      iYaSmooth := 0.0
    else
      iYaSmooth *= Yaw_prop / 100.0
    
    HXP_Act_Pos(iFaSmooth, iLaSmooth, iVaSmooth, iSUaSmooth, iSWaSmooth, iYaSmooth)
    
    ;The real dimension actuator displacements are now in global variables - T_disp_1, T_disp_2, T_disp_3, T_disp_4, T_disp_5, T_disp_6
    ;Convert these into 0-255 scale actuator displacements
    
    HXP_Act_Pos_255(T_disp_1, T_disp_2, T_disp_3, T_disp_4, T_disp_5, T_disp_6)
    
    ;iFaSmooth, iLaSmooth, iVaSmooth, iSUaSmooth, iSWaSmooth, iYaSmooth are now actuator displacements in 0-255 scale

		}

; for any other type of rig flag error
 
	else 
    {
      MsgBox, Rig_Type is not set = 4 or 5 for 6 DOF Hexapod....
      Goto Finish
		}

	;Will default to uncoupled - use cues directly
	
; =================================================
; final sections to handle cue data output
; =================================================

Output:

;If iscope=1 then scope the position demands...

  if (iscope1 = 1)
    {
    if (Scope_Mode1 = 1)
    {
      Title := "BFF Motion Driver Cue by Actuator - Act1 (Green), Act2 (Pink), Act3 (Yellow)"
      rc_scope := Scope(Title, iFASmooth2, iLASmooth2, iVASmooth2, hModule_Scope, hScope1, Mode, Scope_Init1)
    }
    else 
    {
      Title := "BFF Motion Driver Cue by DOF - Pitch (Rads - Green), Surge (mm - Pink), Forward Accel (m/s^2 - Yellow)"
      ;Title := "BFF Motion Driver Cue by DOF - Delta_Pos (m - Green), Delta_T (s - Pink), Velocity (m/s - Yellow)"
      rc_scope := Scope(Title, iFASmooths, iSUASmooths, Faccs, hModule_Scope, hScope1, Mode, Scope_Init1)
      ;rc_scope := Scope(Title, FVel, Facc, Facc_unsmoothed, hModule_Scope, hScope1, Mode, Scope_Init1)
      ;rc_scope := Scope(Title, FVel_unsmoothed, Delta_T_Local, Delta_T_PSX, hModule_Scope, hScope1, Mode, Scope_Init1)
    
    }
    if rc_scope
      Goto Finish
    }
  
  if (iscope2 = 1)
    {
    if (Scope_Mode2 = 1)
    {
      Title := "BFF Motion Driver Cue by Actuator - Act4 (Green), Act5 (Pink), Act6 (Yellow)"
      rc_scope := Scope(Title, iSUASmooth2, iSWASmooth2, iYASmooth2, hModule_Scope, hScope2, Mode, Scope_Init2)
    }
    else 
    {
      Title := "BFF Motion Driver Cue by DOF - Roll (Rads - Green), Sway (mm - Pink), Lateral Accel( m/s^2 - Yellow)"
      ;Title := "BFF Motion Driver Cue by DOF - Accel_Smoothed (m/s^2 - Green), Vel Smoothed (m/s - Pink), Accel (m/s^2 - Yellow)"
      rc_scope := Scope(Title, iLASmooths, iSWASmooths, Laccs, hModule_Scope, hScope2, Mode, Scope_Init2)
      ;rc_scope := Scope(Title, Delta_T_PSX, Facc, FVel_unsmoothed, hModule_Scope, hScope2, Mode, Scope_Init2)
      ;rc_scope := Scope(Title, Facc, FVel, Facc_unsmoothed, hModule_Scope, hScope2, Mode, Scope_Init2)
    }
    if rc_scope
      Goto Finish
    }
  
  if (iscope3 = 1)
    {
    if (Scope_Mode3 = 1)
    {
      Title := "BFF Motion Driver Cue by Actuator - Act4 (Green), Act5 (Pink), Act6 (Yellow)"
      rc_scope := Scope(Title, iSUASmooth2, iSWASmooth2, iYASmooth2, hModule_Scope, hScope3, Mode, Scope_Init3)
    }
    else 
    {
      Title := "BFF Motion Driver Cue by DOF - Heave (mm - Green), Yaw (Rad - Pink), Vert Accel (m/s^2 - Yellow)"
      rc_scope := Scope(Title, iVASmooths, iYASmooths, Vacc2s, hModule_Scope, hScope3, Mode, Scope_Init3)
      ;rc_scope := Scope(Title, Delta_T_PSX_prev, Delta_PosV, VelV_unsmoothed, hModule_Scope, hScope3, Mode, Scope_Init3)
      ;rc_scope := Scope(Title, Delta_T_PSX, Delta_VelV, Vacc2, hModule_Scope, hScope3, Mode, Scope_Init3)
    }
    if rc_scope
      Goto Finish
    }

	iCode := 1
	iCode2 := 0
	
;ramp between hold and drive settings
	
	DllCall("QueryPerformanceCounter", "Int64*", T_Now_D)
  T_Drive_Now := T_Now_D * 1.0 / aaCal
  T_D_Elapsed := T_Drive_Now - T_Drive

	if (icount < Nsets)			;Don't output live Heave or Roll until the High Pass filters have stabilised
		{
		iFaSmooth2 := PitchStart
		iVaSmooth2 := HeaveStart
		iLaSmooth2 := RollStart
		iSUaSmooth2 := SurgeStart
		iSWaSmooth2 := SwayStart
		iYaSmooth2 := YawStart
		iCode := 5
		iCode2 := 1   ;initialising
		}
  else if (iDrive = 0) ;if on hold send the demand towards the start positions
    {
      gui, font, cBlack w600
      GuiControl, Font, myText7
      GuiControl,,myText7, HOLDING....
      
      if (Mode = "KANG" AND icount = NSets) ;ie kangaroo mode and 1st active output loop
      {
        if K_1_Active
          iFaSmooth_last := K_1_Pos_loc  
        if K_2_Active
          iLaSmooth_last := K_2_Pos_loc
        if K_3_Active
          iVaSmooth_last := K_3_Pos_loc
        if K_4_Active
          iSUaSmooth_last := K_4_Pos_loc  
        if K_5_Active
          iSWaSmooth_last := K_5_Pos_loc
        if K_6_Active
          iYaSmooth_last := K_6_Pos_loc
      }
      
      Delta_F := PitchStart - iFaSmooth_last
      iFaSmooth2 := (iFaSmooth_last + (Delta_F * 0.01))
      Delta_V := HeaveStart - iVaSmooth_last
      iVaSmooth2 := (iVaSmooth_last + (Delta_V * 0.01))
      Delta_L := RollStart - iLaSmooth_last
      iLaSmooth2 := (iLaSmooth_last + (Delta_L * 0.01))
      
      Delta_SU := SurgeStart - iSUaSmooth_last
      iSUaSmooth2 := (iSUaSmooth_last + (Delta_SU * 0.01))
      Delta_Y := YawStart - iYaSmooth_last
      iYaSmooth2 := (iYaSmooth_last + (Delta_Y * 0.01))
      Delta_SW := SwayStart - iSWaSmooth_last
      iSWaSmooth2 := (iSWaSmooth_last + (Delta_SW * 0.01))
      
      iFaSmooth_last := iFaSmooth2
      iLaSmooth_last := iLaSmooth2
      iVaSmooth_last := iVaSmooth2
      
      iSUaSmooth_last := iSUaSmooth2
      iSWaSmooth_last := iSWaSmooth2
      iYaSmooth_last := iYaSmooth2
      
      ;MsgBox, %Delta_SW%:%iSWaSmooth%:%iSWaSmooth_last%  ;:%%:%%:%%:%%
		  
		  iCode2 := 2   ;holding
    }
  else if (iDrive = 1 AND T_D_Elapsed < 10.0) ;if drive has recently been selected send the demand towards the mid-stroke positions
    {
      Gui, font, cRed w600
      GuiControl, Font, myText7  
      GuiControl,, myText7, SETTING...
      
      Delta_F := iFaSmooth - iFaSmooth_last
      iFaSmooth2 := (iFaSmooth_last + (Delta_F * 0.01))
      Delta_V := iVaSmooth - iVaSmooth_last
      iVaSmooth2 := (iVaSmooth_last + (Delta_V * 0.01))
      Delta_L := iLaSmooth - iLaSmooth_last
      iLaSmooth2 := (iLaSmooth_last + (Delta_L * 0.01))
      
      Delta_SU := iSUaSmooth - iSUaSmooth_last
      iSUaSmooth2 := (iSUaSmooth_last + (Delta_SU * 0.01))
      Delta_Y := iYaSmooth - iYaSmooth_last
      iYaSmooth2 := (iYaSmooth_last + (Delta_Y * 0.01))
      Delta_SW := iSWaSmooth - iSWaSmooth_last
      iSWaSmooth2 := (iSWaSmooth_last + (Delta_SW * 0.01))
      
      iFaSmooth_last := iFaSmooth2
      iLaSmooth_last := iLaSmooth2
      iVaSmooth_last := iVaSmooth2
      
      iSUaSmooth_last := iSUaSmooth2
      iSWaSmooth_last := iSWaSmooth2
      iYaSmooth_last := iYaSmooth2
      
      
      
      iCode2 := 3   ;setting
    }
  else
    {
      gui, font, cGreen w600
      GuiControl, Font, myText7
      GuiControl,, myText7, DRIVING...
      
      iFaSmooth_last := iFaSmooth
      iLaSmooth_last := iLaSmooth
      iVaSmooth_last := iVaSmooth
      
      iSUaSmooth_last := iSUaSmooth2
      iSWaSmooth_last := iSWaSmooth2
      iYaSmooth_last := iYaSmooth2
      
      iVaSmooth2 := iVaSmooth
      iLaSmooth2 := iLaSmooth
      iFaSmooth2 := iFaSmooth
      
      iYaSmooth2 := iYaSmooth
      iSWaSmooth2 := iSWaSmooth
      iSUaSmooth2 := iSUaSmooth
      
      iCode2 := 4   ;driving
    }

;Disable Drive buttons until the High Pass filters have stabilised
  
	if (icount < Nsets)			
		{
		  GuiControl, Disable, Hold_Start_Pos
		  GuiControl, Disable, _Drive
		  ;GuiControl, Disable, Start_PID_Controller
		  GuiControl, Disable, Re_Load
		  GuiControl, Disable, Re_Set
		  GuiControl, Disable, P
      GuiControl, Disable, R
      GuiControl, Disable, H
      GuiControl, Disable, Y
      GuiControl, Disable, M
		  if (v_Mode != "NONE")
		  {
		  GuiControl, Disable, Slider_H
      GuiControl, Disable, Slider_V
      GuiControl, Disable, Slider_T
      GuiControl, Disable, Scale_H
      GuiControl, Disable, Scale_V
      GuiControl, Disable, Scale_T
      GuiControl, Disable, Enable_Vis
      }
      GuiControl, Disable, Manual_Override
      GuiControl, Disable, ACT_DOF
		}
	else if (icount = Nsets + 1)			;Enable Drive buttons
		{
		  GuiControl, Enable, Hold_Start_Pos
		  GuiControl, Enable, _Drive
		  ;if (Mode = "MEM")
		    ;GuiControl, Enable, Start_PID_Controller
		  if (Mode != "SCN5")
		  {
		    GuiControl, Enable, Re_Load
		    GuiControl, Enable, Re_Set
		  }
		  GuiControl, Enable, R
      GuiControl, Enable, P
      GuiControl, Enable, H
      GuiControl, Enable, Y
      if (Rig_Type = 4 OR Rig_Type = 5)
        GuiControl, Enable, M
		  if (v_Mode != "NONE")
		  {
		    GuiControl, Enable, Slider_H
        GuiControl, Enable, Slider_V
        GuiControl, Enable, Slider_T
        GuiControl, Enable, Scale_H
        GuiControl, Enable, Scale_V
        GuiControl, Enable, Scale_T
        GuiControl, Enable, Enable_Vis
      }
      GuiControl, Enable, Manual_Override
		  GuiControl, Enable, ACT_DOF   
      GuiControl, Enable, Capture
      GuiControl, Enable, S1
      GuiControl, Enable, S2   
      GuiControl, Enable, S3
		}

; Override the position demand outputs with the manual override slider values if active

  if (i_manual = 1 AND ACT_DOF = 0)
    {
      GuiControlGet, man_pos1, 3:
      GuiControlGet, man_pos2, 3:
      GuiControlGet, man_pos3, 3:
      GuiControlGet, man_pos4, 3:
      GuiControlGet, man_pos5, 3:
      GuiControlGet, man_pos6, 3:
      
      if (i_Together = 1)   ;channels 2 & 3 follow channel 1 movements
        {
          delta_man_pos1 := man_pos1 - man_pos1_prev
            
          man_pos2 += delta_man_pos1
          man_pos3 += delta_man_pos1
          man_pos4 += delta_man_pos1
          man_pos5 += delta_man_pos1
          man_pos6 += delta_man_pos1
          
          if (man_pos1 > mp1_max)
            man_pos1 := mp1_max
          else if (man_pos1 < mp1_min)
            man_pos1 := mp1_min
            
          if (man_pos2 > mp2_max)
            man_pos2 := mp2_max
          else if (man_pos2 < mp2_min)
            man_pos2 := mp2_min
            
          if (man_pos3 > mp3_max)
            man_pos3 := mp3_max
          else if (man_pos3 < mp3_min)
            man_pos3 := mp3_min
            
          if (man_pos4 > mp4_max)
            man_pos4 := mp4_max
          else if (man_pos4 < mp4_min)
            man_pos4 := mp4_min
            
          if (man_pos5 > mp5_max)
            man_pos5 := mp5_max
          else if (man_pos5 < mp5_min)
            man_pos5 := mp5_min
            
          if (man_pos6 > mp6_max)
            man_pos6 := mp6_max
          else if (man_pos6 < mp6_min)
            man_pos6 := mp6_min
            
          GuiControl, 3:, man_pos2, %man_pos2%
          GuiControl, 3:, man_pos3, %man_pos3%
          GuiControl, 3:, man_pos4, %man_pos4%
          GuiControl, 3:, man_pos5, %man_pos5%
          GuiControl, 3:, man_pos6, %man_pos6%   
        }
 
      iFaSmooth2 := man_pos1
      iLaSmooth2 := man_pos2
      iVaSmooth2 := man_pos3
      iSUaSmooth2 := man_pos4
      iSWaSmooth2 := man_pos5
      iYaSmooth2 := man_pos6
      
      man_pos1_prev := man_pos1
      man_pos2_prev := man_pos2
      man_pos3_prev := man_pos3
      man_pos4_prev := man_pos4
      man_pos5_prev := man_pos5
      man_pos6_prev := man_pos6
      
      ;Set the last positions
      iFaSmooth_last := iFaSmooth2
      iLaSmooth_last := iLaSmooth2
      iVaSmooth_last := iVaSmooth2
      
      iSUaSmooth_last := iSUaSmooth2
      iSWaSmooth_last := iSWaSmooth2
      iYaSmooth_last := iYaSmooth2
    }

;Insert a very small fluctuation for the high res outputs to MEM

  Random, rand, 0.999999, 1.0000
  iFaSmooth2 *= rand
  iLaSmooth2 *= rand
  iVaSmooth2 *= rand
  
  iSUaSmooth2 *= rand
  iSWaSmooth2 *= rand
  iYaSmooth2 *= rand


;Set up the boolean indicators and export the data

	if (icount > 10)
		{
    
		;If a crank arm actuator is being used then these linear position demands need to be converted into crank rotation demands

    if (Crank_radius != 0)
    {
      iFaSmooth3 := Crank_Adjust(iFaSmooth2)
      iLaSmooth3 := Crank_Adjust(iLaSmooth2)
      iVaSmooth3 := Crank_Adjust(iVaSmooth2)
      iSUaSmooth3 := Crank_Adjust(iSUaSmooth2)
      iSWaSmooth3 := Crank_Adjust(iSWaSmooth2)
      iYaSmooth3 := Crank_Adjust(iYaSmooth2)
      
      iFaSmooth3_bar := iFaSmooth3 * 10
      iLaSmooth3_bar := iLaSmooth3 * 10
      iVaSmooth3_bar := iVaSmooth3 * 10
    
      iSUaSmooth3_bar := iSUaSmooth3 * 10
      iSWaSmooth3_bar := iSWaSmooth3 * 10
      iYaSmooth3_bar := iYaSmooth3 * 10
    
		  GuiControl,, PitchBar, %iFaSmooth3_bar%					
		  GuiControl,, RollBar, %iLaSmooth3_bar%
		  GuiControl,, HeaveBar, %iVaSmooth3_bar%
		
		  GuiControl,, SurgeBar, %iSUaSmooth3_bar%					
		  GuiControl,, SwayBar, %iSWaSmooth3_bar%
		  GuiControl,, YawBar, %iYaSmooth3_bar%
    }
    else
    {  
 
      iFaSmooth2_bar := iFaSmooth2 * 10
      iLaSmooth2_bar := iLaSmooth2 * 10
      iVaSmooth2_bar := iVaSmooth2 * 10
    
      iSUaSmooth2_bar := iSUaSmooth2 * 10
      iSWaSmooth2_bar := iSWaSmooth2 * 10
      iYaSmooth2_bar := iYaSmooth2 * 10
    
  		GuiControl,, PitchBar, %iFaSmooth2_bar%					
  		GuiControl,, RollBar, %iLaSmooth2_bar%
  		GuiControl,, HeaveBar, %iVaSmooth2_bar%
		
  		GuiControl,, SurgeBar, %iSUaSmooth2_bar%					
  		GuiControl,, SwayBar, %iSWaSmooth2_bar%
  		GuiControl,, YawBar, %iYaSmooth2_bar%
    }
	
		;And do the data export - but limit this to 100Hz
    
    if (DeltaT < 0.01)
      {
			;do nothing
			}
    
    else if (Mode = "NONE")
			{
			;do nothing
			}
		
		else if (Mode = "BINW")
			{
			SendCom4(Handle2, iCode, iFASmooth2, iLASmooth2, iVASmooth2)
			}
		else if (Mode = "BIN")
			{
			if (Crank_radius != 0)
        SendCom_6DOF(Handle2, iCode, iFASmooth3, iLASmooth3, iVASmooth3, iSUASmooth3, iSWASmooth3, iYASmooth3)
      else
        SendCom_6DOF(Handle2, iCode, iFASmooth2, iLASmooth2, iVASmooth2, iSUASmooth2, iSWASmooth2, iYASmooth2)
			}
		else if (Mode = "BIN2B")
      {
			if (Crank_radius != 0)
        SendCom_6DOF_2B(Handle2, iCode, iFASmooth3, iLASmooth3, iVASmooth3, iSUASmooth3, iSWASmooth3, iYASmooth3)
      else
        SendCom_6DOF_2B(Handle2, iCode, iFASmooth2, iLASmooth2, iVASmooth2, iSUASmooth2, iSWASmooth2, iYASmooth2)
			}
		else if (Mode = "BIN2TH")
      {
			if (Crank_radius != 0)
        SendCom_6DOF_2TH2(m_pViewBFF, iCode, iFASmooth3, iLASmooth3, iVASmooth3, iSUASmooth3, iSWASmooth3, iYASmooth3)
      else
        SendCom_6DOF_2TH2(m_pViewBFF, iCode, iFASmooth2, iLASmooth2, iVASmooth2, iSUASmooth2, iSWASmooth2, iYASmooth2)
			}
    else if (Mode = "BINTH")
			{
			if (Crank_radius != 0)
        SendCom_6DOF_2TH(Handle2, iCode, iFASmooth3, iLASmooth3, iVASmooth3, iSUASmooth3, iSWASmooth3, iYASmooth3)
      else
        SendCom_6DOF_2TH(Handle2, iCode, iFASmooth2, iLASmooth2, iVASmooth2, iSUASmooth2, iSWASmooth2, iYASmooth2)
			}

		
		;else if (Mode = "BINH")
		;	{
		;	SendCom(Handle2, iCode2, iFASmooth2, iLASmooth2, iVASmooth2)
		;	}
		
		else if (Mode = "POLO")
		{
			if (Crank_radius != 0)
        SendCom_Pol(Handle2, iFASmooth3, iLASmooth3, iVASmooth3, iSUASmooth3, iSWASmooth3, iYASmooth3)
      else
        SendCom_Pol(Handle2, iFASmooth2, iLASmooth2, iVASmooth2, iSUASmooth2, iSWASmooth2, iYASmooth2)
		}

    else if (Mode = "MAEST")
		{
			if (Crank_radius != 0)
        SendCom_PolM(Handle2, iFASmooth3, iLASmooth3, iVASmooth3, iSUASmooth3, iSWASmooth3, iYASmooth3)
      else
        SendCom_PolM(Handle2, iFASmooth2, iLASmooth2, iVASmooth2, iSUASmooth2, iSWASmooth2, iYASmooth2)
		}
        
		else if (Mode = "KANG")
			{
			if (icount >= NSets)
      {
        ;GuiControl,, HexOut, Kang Out: %iFASmooth3% %iLASmooth3% %iVASmooth3% %iSUASmooth3% %iSWASmooth3% %iYASmooth3%
        if (Crank_radius != 0)
          SendKang(Handle2, iFASmooth3, iLASmooth3, iVASmooth3, iSUASmooth3, iSWASmooth3, iYASmooth3)
        else
          SendKang(Handle2, iFASmooth2, iLASmooth2, iVASmooth2, iSUASmooth2, iSWASmooth2, iYASmooth2)
        
        ;Check each of the kangaroo channels for contol errors - but not all at once
        K_check_cnt += 2
        if (K_check_cnt >= 61)
          K_check_cnt := 0
          
        if (K_check_cnt = 10 AND K_1_Active = 1)
        {
          iret := KangGet(Handle2, K_1_Adr, K_1_Chn, 1, Result)
          if (iret = 3)
          {
            MsgBox WARNING - Kangaroo on actuator 1 has reported a control error`n`n...about to return other actuators to park position.....
            iDrive := 0
            K_1_Active = 0
          }
        }
        else if (K_check_cnt = 20 AND K_2_Active = 1)
        {
          iret := KangGet(Handle2, K_2_Adr, K_2_Chn, 1, Result)
          if (iret = 3)
          {
            MsgBox WARNING - Kangaroo on actuator 2 has reported a control error`n`n...about to return other actuators to park position.....
            iDrive := 0
            K_2_Active = 0
          }
        }
        else if (K_check_cnt = 30 AND K_3_Active = 1)
        {
          iret := KangGet(Handle2, K_3_Adr, K_3_Chn, 1, Result)
          if (iret = 3)
          {
            MsgBox WARNING - Kangaroo on actuator 3 has reported a control error`n`n...about to return other actuators to park position.....
            iDrive := 0
            K_3_Active = 0
          }
        }
        else if (K_check_cnt = 40 AND K_4_Active = 1)
        {
          iret := KangGet(Handle2, K_4_Adr, K_4_Chn, 1, Result)
          if (iret = 3)
          {
            MsgBox WARNING - Kangaroo on actuator 4 has reported a control error`n`n...about to return other actuators to park position.....
            iDrive := 0
            K_4_Active = 0
          }
        }
        else if (K_check_cnt = 50 AND K_5_Active = 1)
        {
          iret := KangGet(Handle2, K_5_Adr, K_5_Chn, 1, Result)
          if (iret = 3)
          {
            MsgBox WARNING - Kangaroo on actuator 5 has reported a control error`n`n...about to return other actuators to park position.....
            iDrive := 0
            K_5_Active = 0
          }
        }
        else if (K_check_cnt = 60 AND K_6_Active = 1)
        {
          iret := KangGet(Handle2, K_6_Adr, K_6_Chn, 1, Result)
          if (iret = 3)
          {
            MsgBox WARNING - Kangaroo on actuator 6 has reported a control error`n`n...about to return other actuators to park position.....
            iDrive := 0
            K_6_Active = 0
          }
        }
      }
      else
        K_check_cnt := 0
        Result := 0
			}		
		  
		else			;ie not recongnised
			{
        MsgBox, Data output mode "%Mode%" not recognised.... closing driver
        Goto Finish
      }




		}

;Post action trace of demanded and actual positions for GAL output
	if (itrace = 13)
		{
		D1%icount% := iFaSmooth2		;record the output cues
		D2%icount% := iLaSmooth2
		D3%icount% := iVaSmooth2
		D4%icount% := pos1_act		;record the actual actuator positions if available from the DMC controller
		D5%icount% := pos2_act
		D6%icount% := pos3_act
		D7%icount% :=
		}

;Progress text displays

  if (Crank_radius != 0)
  {
  iFaSmooth3o := Round(iFaSmooth3,2)
  iLaSmooth3o := Round(iLaSmooth3,2)
  iVaSmooth3o := Round(iVaSmooth3,2)
  
  iSUaSmooth3o := Round(iSUaSmooth3,2)
  iSWaSmooth3o := Round(iSWaSmooth3,2)
  iYaSmooth3o := Round(iYaSmooth3,2)
  

	if (Rig_Type = 4 OR Rig_Type = 5)
		{
		GuiControl,, PitchOut, Act 1 Output..%iFaSmooth3o%
		GuiControl,, RollOut, Act 2 Output...%iLaSmooth3o%
		GuiControl,, HeaveOut, Act 3 Output...%iVaSmooth3o%
		
		GuiControl,, SurgeOut, Act 4 Output...%iSUaSmooth3o%
		GuiControl,, SwayOut, Act 5 Output...%iSWaSmooth3o%
		GuiControl,, YawOut, Act 6 Output...%iYaSmooth3o%
		}
	else
		{
		GuiControl,, PitchOut, Pitch Cue Output...%iFaSmooth3o%
		GuiControl,, RollOut, Roll Cue Output...%iLaSmooth3o%
		GuiControl,, HeaveOut, Heave Cue Output...%iVaSmooth3o%
		
		GuiControl,, SurgeOut, Surge Cue Output...%iSUaSmooth3o%
		GuiControl,, SwayOut, Sway Cue Output...%iSWaSmooth3o%
		GuiControl,, YawOut, Yaw Cue Output...%iYaSmooth3o%
		}    
  }

  else
  {
  iFaSmooth2o := Round(iFaSmooth2,2)
  iLaSmooth2o := Round(iLaSmooth2,2)
  iVaSmooth2o := Round(iVaSmooth2,2)
  
  iSUaSmooth2o := Round(iSUaSmooth2,2)
  iSWaSmooth2o := Round(iSWaSmooth2,2)
  iYaSmooth2o := Round(iYaSmooth2,2)
  

	if (Rig_Type = 4 OR Rig_Type = 5)
		{
		GuiControl,, PitchOut, Act 1 Output..%iFaSmooth2o%
		GuiControl,, RollOut, Act 2 Output...%iLaSmooth2o%
		GuiControl,, HeaveOut, Act 3 Output...%iVaSmooth2o%
		
		GuiControl,, SurgeOut, Act 4 Output...%iSUaSmooth2o%
		GuiControl,, SwayOut, Act 5 Output...%iSWaSmooth2o%
		GuiControl,, YawOut, Act 6 Output...%iYaSmooth2o%
		}
	else
		{
		GuiControl,, PitchOut, Pitch Cue Output...%iFaSmooth2o%
		GuiControl,, RollOut, Roll Cue Output...%iLaSmooth2o%
		GuiControl,, HeaveOut, Heave Cue Output...%iVaSmooth2o%
		
		GuiControl,, SurgeOut, Surge Cue Output...%iSUaSmooth2o%
		GuiControl,, SwayOut, Sway Cue Output...%iSWaSmooth2o%
		GuiControl,, YawOut, Yaw Cue Output...%iYaSmooth2o%
		}
	}

	icount += 1


; That's the processing complete for this data set - go get the next...however

;1st Check if BackSlash+R are pressed to initiate a Vert Accel Recording Run

	GetKeyState, state1, \	; Check if \ key is depressed
	if state1 = D
		{
		GetKeyState, state2, R	;Check if R is also depressed
		if state2 = D
			{
			icnt_on := 1		;Switch the record flag on
			MsgBox, In Light Turbulence Recording Mode
			}
		}

	if (icnt_rec = 2000)			;If the recording counter has reached 2000 - write the recorded data out to the BFF-turb.txt text file in the working directory
		{
		FileDelete, BFF-Turb.txt
		MsgBox, About to Write Turbulence Data File - Please Minimise FS9 & Continue
		Loop 2000
			{
			recdata := recd%A_Index%
			FileAppend, %recdata%`n, BFF-Turb.txt
			}
		MsgBox, Leaving Recording Mode And Finishing - Please Restart the Motion Driver
		goto Finish
		}

	if (icnt_on = 1)
		icnt_rec += 1		;If the record flag is on index the record counter

;Okay go get the next data now

goto MainLoop


return


;
;hot keys to show the main window
;
^+s::    ;Ctrl Shift S
GUI, 1:Show, x%posx1% y%posy1%
return

;
;hot keys to hide the main window
;
^+h::    ;Ctrl Shift H
WinGetPos, posx1, posy1, , , BFF 6-DOF Platform Motion Driver
GUI, 1:Cancel
return



;That's it

ButtonExit:
GuiClose:
Finish:

;Dump recorded data if trace flag is on.... will take a few moments
if (itrace > 0) AND (itrace != 100)
	{
	GuiControl,, MyText, Writing trace data to BFF-output.txt...........please wait.
	
	if (itrace = 5 or itrace = 12)
	 FileAppend, Lat Yaw Vert Bank Fwd Pitch`n, bff-output.txt
	else if (itrace >= 6 AND itrace <= 11)
	 FileAppend, Vel_Raw After_TN After_TW Capped Inverted Servo_Mvmnt Servo_Out`n, bff-output.txt
	else if (itrace = 1)
	 FileAppend, iFaSmooth iLaSmooth iVaSmooth Facc Lacc Vacc2 T_Now`n, bff-output.txt
	 
	Loop %icount%		
		{
		P1 := D1%A_Index%
		P2 := D2%A_Index%
		P3 := D3%A_Index%
		P4 := D4%A_Index%
		P5 := D5%A_Index%
		P6 := D6%A_Index%
		P7 := D7%A_Index%
		FileAppend, %P1% %P2% %P3% %P4% %P5% %P6% %P7%`n, bff-output.txt
		}
	}


GuiControl,, MyText, Closing COM Port and Exiting...........
if Regtxt_active
  GuiControl,13:,RegTxt2, Closing COM Port and Exiting.....
Sleep, 250

;Tell PRY_Speed to stop...

VarSetCapacity(Char_Byte, 1, 0)
NumPut(1, Char_Byte, 0, "UChar")
DllCall("RtlMoveMemory", "Uint", m_pViewBFF + 210, "Uint", &Char_Byte, "Int", 1)
Sleep, 500


;Powerdown the kangaroos if active

if (Mode = "KANG")
{
  KangPowerDown(Handle2, K_1_Adr)
  KangPowerDown(Handle2, K_2_Adr)
  KangPowerDown(Handle2, K_3_Adr)
  KangPowerDown(Handle2, K_4_Adr)
  KangPowerDown(Handle2, K_5_Adr)
  KangPowerDown(Handle2, K_6_Adr)
}

;Close the COM Port on exiting the program
DllCall("CloseHandle", UInt, Handle2)
DllCall("CloseHandle", UInt, Handle3)

;Close down the Shared Memory elements
DllCall("UnmapViewOfFile", "Uint", m_pViewBFF)
DllCall("CloseHandle", UInt, m_hMapBFF)

;And close down the TCP sockets etc
DllCall("Ws2_32\closesocket", "Uint", X_Socket)
DllCall("Ws2_32\WSACleanup")

;Destroy the scope & free library
if (iscope = 1)
{
  rc := DllCall("Osc_DLL\ScopeDestroy", Int, hScope, "Cdecl Int")
  DllCall("FreeLibrary", "UInt", hModule_Scope)
}

if (Mode = "SCN5")
{
;Close down the Shared Memory elements
  DllCall("UnmapViewOfFile", "Uint", m_pViewBFF_TB)
  DllCall("CloseHandle", UInt, m_hMapBFF_TB)
}

ExitApp

;Exit

;Bye.................... other called functions are in separate script files








;Function to read the length of data available at the socket to be read
CheckBuffer(wParam)
{
  ;Global aaCal
  
  Socket := wParam
  FIONREAD = 0x4004667F
  iret := DllCall("Ws2_32\ioctlsocket", "Uint", Socket, "Int", FIONREAD, "Uint*", ReceivedDataSize)
  if ErrorLevel
    {
      MsgBox Error on ioctlsocket %ErrorLevel%.
      return -1
    }
  if iret
  	{
      MsgBox % "ioctlsocket() indicated Winsock error " . DllCall("Ws2_32\WSAGetLastError")
      return -1
    }
  ;GuiControl,, MyText, ReceivedDataSize: %ReceivedDataSize%
  ;DllCall("QueryPerformanceCounter", "Int64*", T_Check)
  ;T_check := T_Check * 1.0 / aaCal
  ;FileAppend, %T_Check% %ReceivedDataSize%`n, Buffer.log 
  Return, %ReceivedDataSize%
}


;Function to display the startup registration reminder window - GUI 13


Disp_RegInfo(Name, Email)
{
  Global RegTxt, RegTxt2, s_val, w_val, w_val_bold
  
  FileAppend, `nDisplaying registration details....`n,Logs\BFF_CL.log

  SetTitleMatchMode, 1
  
  ;Main window position
  WinGetPos, posx, posy, , , BFF 6-DOF Platform Motion Driver
  posx += -5
  posy += 165

  ;GUI
  
  Gui 13:Default
  
  ;Gui, Font, %s_val%
  Gui, Color, Silver
  
  Gui, font, cBlue %s_val% %w_val_bold% s14
  Gui, Add, Text, x12 y20 w450 h30 +Center, BFF Simulation - 6 DOF Motion Driver
  Gui, Font
  Gui, font, cBlue %s_val% %w_val_bold% s10
  Gui, Add, Text, x12 y60 w450 h30 +Center vRegTxt, Registered to....
  Gui, Font
  Gui, Font, %s_val%
  Gui, Add, Text, x12 y100 w450 h40 +Center, THIS SOFTWARE IS LICENCED FOR PERSONAL`, HOME USE ONLY. `n....DO NOT USE FOR COMMERCIAL PURPOSES.... `nReport violations to Ian@builtforfun.co.uk
  Gui, Font, s10
  Gui, Add, Text, x12 y150 w450 h30 +Center vRegTxt2, Initialising.....
  Gui, Font, %s_val%
  Gui, Add, GroupBox, x3 y2 w469 h184,

  Gui, Show, x%posx% y%posy% h194 w479, BFF_Registration
  
  Gui, -SysMenu
  
  WinSet, AlwaysOnTop, On, BFF_Registration
  
  WinSet, Transparent, 255, BFF_Registration
  
  GuiControl,,RegTxt, Registered to %Name% (%Email%)

  Gui 1:Default


Return, 1
}







;Function to check if current registration key is a legacy commercial one...
;Return 0 for NO, 1 for YES
Check_Key(BFF_Key)
{
if (BFF_Key = "68ea4237730626ee"
 OR BFF_Key = "2cd22f35fa09c6b2"
 OR BFF_Key = "cf30b79d720c7fbd"
 OR BFF_Key = "9c07f047ac1f20af")
 {
    FileAppend, `nKey: %BFF_Key% is legacy commercial....`n, Reg.log
    Return, 1
 } 
Return, 0
}





;
;Function to do the registration checks
;
Reg_Check()
{
Global

FileAppend, `n==========================================`nDoing registration checks at %A_Now%.......`n,Reg.log

;List all the files in the directory
FileList =
Loop *
   FileList = %FileList%%A_LoopFileName%`n
   
FileAppend, `nFiles found in working Directory:`n%FileList%`n`n,Reg.log

CL_username := ""
Regtxt_active := 0
Reg_Exist := 0

; Check for registration files - BFF_Registration_v3.ini for home use
;                                BFF_RegistrationPro_v3.ini for commercial use

IfExist, BFF_Registration_v3.ini
{		
  SWP_Initialize(0x54297034, 0x12337798, 0x56731967, 0x56433990, 0x06294839, 0x66572870, 0x09293953, 0x78882334) 
  Reg_File := "BFF_Registration_v3.ini"
  Reg_Exist := 1
  FileAppend, `n`nHome use registration ini found.......`n,Reg.log
}
else
  FileAppend, `n`nNo home use registration ini found.......`n,Reg.log

IfExist, BFF_RegistrationPro_v3.ini ;check for pro second - if both exist then the pro version will take precedence
{		
  SWP_Initialize(0x54397034, 0x12337098, 0x26731967, 0x56453990, 0x06294579, 0x66962870, 0x09293003, 0x78881434) 
  Reg_File := "BFF_RegistrationPro_v3.ini"
  Reg_Exist := 2
  FileAppend, `n`nCommercial use registration ini found.......`n,Reg.log
}
else
  FileAppend, `n`nNo commercial use registration ini found.......`n,Reg.log
;Process the registration

If !Reg_Exist			;No registration file exists
	{
    ;First check if a valid USB dongle exists...
    FileAppend, `n`nNo registration ini found at %A_Now% so chekcing for USB Dongle anyway.....`n, Reg.log
    FileAppend, Checking for USB Dongle .....`n, Reg.log
    iret := USBReadPCID(ID_Read)
    FileAppend, `nUSBReadPCID() has returned %iret% and ID_Read = %ID_Read% .....`n, Reg.log
    if (iret = 0)
    {
      FileAppend, A valid USB licence dongle is present - but there is no matching registration.ini file.`n`nPlease email Ian@builtforfun.co.uk for your matching registration ini file.....`n`nContinuing in Demo mode - the driver will stop in approx 15 minutes.`n, Reg.log
      MsgBox, A valid USB licence dongle is present - but there is no matching registration.ini file.`n`nPlease email Ian@builtforfun.co.uk for your matching registration ini file.....`n`nContinuing in Demo mode - the driver will stop in approx 15 minutes.
      GuiControl,, MyText, Continuing in Demo mode........... will stop in 15 minutes.
		  Sleep, 1000
		  nDemo := 900            ;demo time in seconds
		  Return, 0
    }
    else
    {
      FileAppend, `nNo USB Dongle found either.....`n, Reg.log
      FileAppend, This is an unregistered version. Would you like to register now? (press Yes or No)`n`n(If you select No the driver will stop working after approx. 15 minutes flight use.)`n, Reg.log
      MsgBox, 4,, This is an unregistered version. Would you like to register now? (press Yes or No)`n`n(If you select No the driver will stop working after approx. 15 minutes flight use.) 
      IfMsgBox Yes
      {
		    FileAppend, User replied YES - going to registration dialog...`n, Reg.log
        SWP_CheckRegistration( "BFF Motion Driver v3", "Ian@builtforfun.co.uk", "BFF_Registration_v3.ini" )
		    GuiControl,, MyText, Please restart the driver.......
		    MsgBox, Please restart the driver......
		    Return, 1
      }
      Else
		  {
		    FileAppend, User replied NO - proceeding in DEMO mode...`n, Reg.log
        GuiControl,, MyText, Continuing in Demo mode........... will stop in 15 minutes.
		    Sleep, 2000
		    nDemo := 900            ;demo time in seconds
		    Return, 0
		  }
    }
  }
Else		;The registration file exists - so check its contents
	{
    FileAppend, `nRegistration file found at %A_Now%.....`nChecking registration details.......`n, Reg.log
    GuiControl,, MyText, Checking registration details.......
    Sleep, 1000
    SWP_CheckRegistration( "BFF Motion Driver v3", "Ian@builtforfun.co.uk", Reg_File )
    nDemo := 0
    
    ;Now check if the key is in fact a legacy commercial key - if so do not display the splash screen etc
    if (Reg_Exist = 1)
    {
      iret := Check_Key(BFF_Key)
      if (iret = 1)
        Reg_Exist := 2
    }  
  
    if (Reg_Exist = 1)
    {
      FileAppend, Registration details OK........`nLicenced to %CL_username% for personal non-commercial use only.`n, Reg.log
      GuiControl,,MyText, Licenced to %CL_username% for PERSONAL NON-COMMERCIAL use only.
      GuiControl,,Text_Lic, Licenced to %CL_username% for PERSONAL NON-COMMERCIAL use only.
      Regtxt_active := Disp_RegInfo(CL_username, BFF_User_Email)
    }
    else if (Reg_Exist = 2)
    {
      FileAppend, Registration details OK........`nLicenced to %CL_username% for commercial use.`n, Reg.log
      GuiControl,,MyText, Licenced to %CL_username% for COMMERCIAL use.
      GuiControl,,Text_Lic, Licenced to %CL_username% for COMMERCIAL use.
    }
    
    Sleep, 2000
	}

Return, 0
}

